#include "windows.h"

// P.FREYER 15/05/96    rev 12/12/96
// voir version turbo C 2.00 FAckBusy.c et FrqAB.exe   
//(c) PF 15 mai 96        
// nota:
// Ack=10 de v25=20 de weidmuller  lecture de 0  pour niveau 0   lecture de 64 pour niveau 1
// Busy=11=22 de weidmuller lecture de 128 pour niveau 0    lecture de  0 pour niveau 1
// parametre LPTx
//   En Sortie: 1 mesure front Haut dans Ax
//	    		1 mesure front Bas dans Cx
//	 Hardware:     
//	            Ack= entree pour lecture bit  
// nota: le signal mesur doit etre CARRE  pour eviter les debordements de comptage


int LibMain(HANDLE hModule,WORD wDataSeg,WORD cbHeapSize,LPSTR lpszCmdLine)
{
 return 1;
}

   
char Auteur[]="P.Feyer";   
char Version[]="12 Mai 97";
unsigned int FrontAHaut;
unsigned int FrontABas;  
unsigned int FrontBHaut;
unsigned int FrontBBas;   
unsigned int donnee;   
unsigned int counts;
long FrontA; 
long FrontB; 
float RatioA;            
float RatioB;


int PASCAL __export INPORTB (int Lptx)
{      
 __asm{
	mov dx,Lptx
	in al,dx   
	mov donnee,ax 
	mov ah,0
	};     
	return(donnee);
}



void PASCAL __export OUTPORTB (int Lptx,int Value) 
{  
 __asm {  
	mov ax,Lptx   
	mov dx,ax
	mov ax,Value 
	mov ah,0
	out dx,al
	};
}	
     
  
long PASCAL __export GETACK(int Lptx)
{               
    __asm {          
    cli
    mov dx,Lptx
	inc Dx
	mov cx,0
	mov bx,0
// synchro sur front
t1:
	in Al,dx
	test Al,64
	jz t1
t2:
	in Al,dx
	test Al,64
	jnz t2
t3:
	in Al,dx
	inc bx
	test Al,64
	jz t3
t4:
	in Al,dx
	inc cx
	test Al,64
	jnz t4
t5:
	in Al,dx
	inc bx
	test Al,64
	jz t5
t6:
	in Al,dx
	inc cx
	test Al,64
	jnz t6
t7:
	in Al,dx
	inc bx
	test Al,64
	jz t7
t8:
	in Al,dx
	inc cx
	test Al,64
	jnz t8
t9:
	in Al,dx
	inc bx
	test Al,64
	jz t9
t10:
	in Al,dx
	inc cx
	test Al,64
	jnz t10 
	mov ax,bx
	mov FrontAHaut,ax
	mov ax,cx
	mov FrontABas,ax
	sti    
	} 
	FrontA=(long)FrontAHaut+(long)FrontABas;
return FrontA;   
} 
                   

  
  
float PASCAL __export RATIOACK(int Lptx)
{   
 long dummy;            
    dummy=GETACK(Lptx); 
    if(FrontABas>0) RatioA=(float)FrontAHaut/(float)FrontABas; else return (0);
return RatioA;   
}  


long PASCAL __export GetAckFrontHaut(int Lptx)
{   
 long dummy;            
    dummy=GETACK(Lptx); 
return FrontAHaut;   
}   

long PASCAL __export GetAckFrontBas(int Lptx)
{   
 long dummy;            
    dummy=GETACK(Lptx); 
return FrontABas;   
}                       
       
                   
long PASCAL __export GETBUSY(int Lptx)
{               
    __asm {   
    mov dx,Lptx
	cli
	inc Dx
	mov cx,0
	mov bx,0
p1:
	in Al,dx
	test Al,128
	jnz p1
p2:
	in Al,dx
	test Al,128
	jz p2
p3:
	in Al,dx
	inc bx
	test Al,128
	jnz p3
p4:
	in Al,dx
	inc cx
	test Al,128
	jz p4
p5:
	in Al,dx
	inc bx
	test Al,128
	jnz p5
p6:
	in Al,dx
	inc cx
	test Al,128
	jz p6
p7:
	in Al,dx
	inc bx
	test Al,128
	jnz p7
p8:
	in Al,dx
	inc cx
	test Al,128
	jz p8
p9:
	in Al,dx
	inc bx
	test Al,128
	jnz p9
p10:
	in Al,dx
	inc cx
	test Al,128
	jz p10
p11:
	in Al,dx
	inc bx
	test Al,128
	jnz p11
p12:
	in Al,dx
	inc cx
	test Al,128
	jz p12
	mov ax,bx
	mov FrontBHaut,ax
	mov ax,cx
	mov FrontBBas,ax
	sti    
	} 
	FrontB=(long)FrontBHaut+(long)FrontBBas;
return FrontB;
}


  
float PASCAL __export RATIOBUSY(int Lptx)
{   
 long dummy;            
    dummy=GETBUSY(Lptx);
	if(FrontBBas>0) RatioB=(float)FrontBHaut/(float)FrontBBas; else return (0);
return RatioB;   
}                    
   
    
long PASCAL __export GetBusyFrontHaut(int Lptx)
{   
 long dummy;            
    dummy=GETBUSY(Lptx);
return FrontBHaut;   
}       
   
long PASCAL __export GetBusyFrontBas(int Lptx)
{   
 long dummy;            
    dummy=GETBUSY(Lptx);
return FrontBBas;   
}     
     
   

int PASCAL __export PresenceAck(int Lptx)
{   
  __asm {  
    cli         
    Mov cx,0
	mov dx,Lptx
//  mov al,0        
//	out dx,Al	
//  nop                  
//  nop
//  mov al,2      
//  out dx,Al
    inc dx
encore: 
    in al,dx  
    inc cx
    cmp cx,0x3333
    jz sortie
 	test al,64
    jnz encore  
sortie:         
    mov counts,cx 
    sti
   	} ;    
   return(counts);
 }      
 
 
int PASCAL __export PresenceBusy(int Lptx)
{   
  __asm {  
    cli         
    Mov cx,0
	mov dx,Lptx
    mov al,0        
	out dx,Al	
    nop                  
    nop
    mov al,2      
    out dx,Al
    inc dx
encore: 
    in al,dx  
    inc cx
    cmp cx,0x3333
    jz sortie
 	test al,128
    jnz encore  
sortie:         
    mov counts,cx 
    sti
   	} ;    
   return(counts);
 }      