/*
 version 0.0 08/04/2001
 (c)PF
-----------------------------------------------------------------------------
 Nom    : tst_1241.c        DOS 6.22    Video : Cougard 32Mo
 Date   : 08/04/01          Materiel:   Pentium II 400Mhz
 Auteur : P.FREYER          Langage :   Turbo C v2.00 Borland
 But    : Mesurer et visualiser des signaux electriq. 0  3V   Volts
------------------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <Bios.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include <graphics.h>
#include <alloc.h>

#define _EN_C
#include "d:\tc\scope\enregist.scp"
char Interface[]={"4 composants 1x MAX1241 2x R=1Mohms  c=10F"};
char CopyRight[]={"tst_1241.c 2001 (c)P.Freyer"};
char Version[]={"(C)P.F.V0.1 08-04-2001"};

typedef enum {FALSE,TRUE} bool;
typedef unsigned char byte;
typedef unsigned int word;

word i,j,k,l,m,n;
word x,y,x1,y1;
word tempo;
word LPTx,mot,Valeur;
long MaxiPosition;
int CarteGraphique;
int ModeGraphique;
int ErrorCode;
int MinX,MinY,MaxX,MaxY;
float Moyenne,Total;

char c;
char far *mes;
float te,tf,m1;
byte octet;
int voie;
int Mesu[30000];
int Tmax;
int RM;
float Ecart;
word MicroDelai;    /* 4 pour 486DXII 66 */
word far *RbT;      /* Ram Bios Timer */
long xD,xF,xE ;

#define CR printf("\n");
#define InitADC    outportb(LPTx,1);\
		   outportb(LPTx,0);

struct time T1;

#ifdef _EN_C
#define AutoFeedOn    outportb(LPTx+2,0);
#define AutoFeedOff   outportb(LPTx+2,1);
#define ChipSelect    outportb(LPTx,0);
#define ChipUnselect  outportb(LPTx,2);
#define ClockON     outportb(LPTx,1);
#define ClockOFF    outportb(LPTx,0);
#define ReadBusy    inportb(LPTx+1) & 128
#define Strobe  		ChipSelect;\
				k=2048;\
				ClockON\
				l=0;
#define Acquis  for(i1=0;i1<12;i1++)\
				{\
				ClockOFF\
				if (inportb(LPTx+1)<128) l=l+k;\
				ClockON\
				k=k>>1;\
				};\
                                ChipUnselect;
int LECTADC(int LPTx)
{
word i1,l,k;
Strobe;
Acquis ;
return(l);
}
#endif


void AdjustMicroDelai()
{
  long i;
  xD=*(RbT)+*(RbT+2)*65535;
  i=0;
  while(i<10000000L)i=i+1;
  xF=*(RbT)+*(RbT+2)*65535;
  xE=xF-xD;                     /* duree en 1/18 eme de secondes */
  Ecart=(1000000.0*xE)/18.2;    /* duree en microsecondes */
  MicroDelai=(unsigned int)(Ecart/1000.0);
  printf("\nXd=%10ld \nXF=%10ld \nXE=%10ld\
    \nEcart=%12.3f S pour 10 000 000 de boucles\
    \nMicroDelai pour 10000 boucles =%8d\
    \nDuree de une boucle=%6.6f S",\
    xD,xF,xE,Ecart,MicroDelai,Ecart/10000000);
  if (MicroDelai>10000) MicroDelai=1; else MicroDelai=10000/MicroDelai;
  printf("\nMicroDelai de base =%8d pour 1 S\n",MicroDelai);
sleep(2);
}

void delai_uS(word jjj)           /* delai exprim en S */
{
 long i;
 if (jjj>20)
 {
 i=(long)jjj*MicroDelai;
 while (i>0)i--;
 }
}

void Delay(int jjj)
{
int i;
while (jjj>0)
{
 for (i=0;i<800;i++);
 jjj--;
 }
}

float Duree (void)
{
    float TT1,c1,c2,c3;
    gettime(&T1);
    c1=(float)T1.ti_sec;
    c2=(float)T1.ti_hund;
    c3=(float)T1.ti_min;
    TT1=c3*60+c1+c2/100.0;
return(TT1);
}

void MesureDuree()
{
te=Duree();
for (j=0;j<MaxiPosition;j++)
 {
     Mesu[j]=LECTADC(LPTx);
   delai_uS(tempo);
  }
tf=Duree();
te=tf-te;
}

void Pause()
{
 do
   {}
    while (!kbhit()) ;
    c=getch();
};

void InitGraf()
{
    word i;
    printf("\nInitgraf.c");
    CarteGraphique=VGA;
    ModeGraphique=VGAHI;
    i=registerfarbgifont(triplex_font_far);
    if (i!=1)
    {
        printf("\nPb font TRIP non integree .. CR= %04X",i);
        sleep(2);
        exit(1);
    }
    i=registerfarbgifont(sansserif_font_far);
    if (i!=3)
	{
        printf("\nPb font SANS non integree ..CR=%04X",i);
        sleep(2);
        exit(1);
    }
    i=registerfarbgidriver(EGAVGA_driver_far );
    if (i<0)
    {
        printf("\nPb Driver EGAVGA non integree ..CR=%04X ",i);
        sleep(2);
        exit(1);
     }
    initgraph(&CarteGraphique,&ModeGraphique,"");
    ErrorCode=graphresult();
    if (ErrorCode!=grOk)
    {
        printf("\nerreur init Grafique :%s \n",grapherrormsg(ErrorCode));
        sleep(2);
        exit(1);
    }
    MaxX=getmaxx();
    MaxY=getmaxy();
    printf("\n Max X=%5d MaxY=%5d",MaxX,MaxY);
    sleep(1);
    clearviewport();
 }

void main ()
{
 clrscr();
 Tmax=5;
 tempo=1;
 MaxiPosition=15000L;
 RbT=(char far *)malloc(8);
 RbT= (word *)MK_FP (0x0040,0x006c);
 AdjustMicroDelai();
 mes=(char *) farmalloc(256);
 clrscr();
 textcolor(14);
 cprintf("tst_1241.c  ");
 printf("\navec ADC 12 bits serie Max1241 (8 pins) sur port LPTx ");
 printf("\nVersion 0.3 (C)P.Freyer. ");
 printf("\n\n");
 printf("\nNota: duree mini clock ADC <1  10000>  ajuster par U et D ");
 printf("\n 14 Autofeed  @+2  2  inv     ->  3  de Max1241  SHDN");
 printf("\n 11 Busy      @+1  128        <-  6  de Max1241  DOUT");
 printf("\n 2  D0        @+0  1          <-> 8  de Max1241  SCLK");
 printf("\n 3  D1        @+0  2          <-> 7  de Max1241  CS");
 octet=0;
 textcolor(13);
 CR;
 CR;
 cprintf("Choix port Lpt <1> ou <2> : ");
 do
 {
   scanf("%1d",&i);
 }
 while (i<1 && i>2);
 switch (i)
 {
   case 1 :LPTx=888;break;
   case 2 :LPTx=632;break;
 }
 outportb(LPTx,0);
 outportb(LPTx+1,0);
 outportb(LPTx+2,0);
 textcolor(15);
 cprintf("Esc pour suite..");
 do
    {
    Valeur=LECTADC(LPTx);
    gotoxy(1,20);
    printf(" Valeur brute=%05d    %04x  %05.2fmV",Valeur,Valeur,(float)(Valeur)*6200.0/4096.0);
    if (kbhit()) c=(char) getch();
 }
 while(c!=27);

voie=0;
c=0;
InitGraf();
AutoFeedOn;
MesureDuree();
do
{
  outportb(LPTx,4);
  for (j=0;j<640;j++)
  {
   Mesu[j]=LECTADC(LPTx);
   delai_uS(tempo);
  }
   outportb(LPTx,4);
  Total=0;
  for (j=0;j<640;j++){ Total=Total+(float)Mesu[j]; }
  setviewport(1,1,679,20,1);
  clearviewport();
  setcolor(12);
  i=sprintf(mes,"ESC=sortie  %8lu mes. en %06.3fSec soit %06.3f S par point",MaxiPosition,te,te*1000000/(float)MaxiPosition);
  outtextxy(5,5,mes);
  Moyenne=Total/640.0;   /* en points */
  setcolor(2);
  line(0,480-Moyenne/8,639,480-Moyenne/8);
  RM=(int)Moyenne;
  Moyenne=Moyenne*6.2/4.096;  /* en volts */
  i=sprintf(mes," moy= %06d points ou %06.0f mV tempo=%06d",RM,Moyenne,tempo);
  outtextxy(5,15,mes);

  setlinestyle(SOLID_LINE,0,1);
  setcolor(14);
  moveto  (1,480-Mesu[0]/8);
  putpixel(1,480-Mesu[0]/8,12);
  setcolor(14);
  outportb(LPTx,0);
  for (x=1;x<640;x++) lineto(x,480-Mesu[x]/8);

   for (m1=1000.0;m1<7000.0;m1=m1+1000.0)
  {
  Moyenne=(m1*4096)/6200;
  setcolor(8);
  setlinestyle(DASHED_LINE,0,1);
  line(20,480-Moyenne/8,639,480-Moyenne/8);
  i=sprintf(mes,"%6.2fV",m1/1000);
  outtextxy(5,475-Moyenne/8,mes);
  }

  setviewport(1,20,679,1,1);
  if (kbhit()) { c=(char) getch(); c=toupper(c);}
  switch (c)
  {
  case 'P':
      i=sprintf(mes,"- Pause      -");
      outtextxy(460,1,mes);
      do
      {}
      while (!kbhit());
      i=sprintf(mes,"-            -");
      outtextxy(460,1,mes);
      c=0;
      break;
  case 'U' :
   if (tempo<10000) tempo++;
   c=0;
   break;
  case 'D' :
   if (tempo>1) tempo--;
   c=0;
   break;
  case 'R' :
   MesureDuree();
   c=0;
   break;
  }
 delai_uS(tempo);          /* delai exprim en S */
 }
 while(c!=27);
 c=0;
 closegraph();
 farfree(mes);
 printf("\n\n Fin normale de programme....");
 printf("\n Version : %s",Version);
 printf("\n Interface : %s\n\n",Interface);
 sleep(2);
}
