#include <iomanip.h> 
#include <time.h>  
#include <stdio.h>
#include <stdlib.h>
#include <Dos.h>
#include <Bios.h>
#include <conio.h>
#include <fcntl.h>
#include <string.h>
#include <math.h>    
//#include "winuser.h"

#define MaxiBoucles 3200


float HorlogeHP;
int Lptx;
int counts; 
int Etat;  
char c;
char Nom[32];
char *Tampon;
unsigned int i,j,k;
long TDebut;
long TFin;
static int Table[MaxiBoucles+2];
int huge *ptr ;
char *NomUnite;   




void AutoFeedOn (int Lptx)
{
 __asm
 {
    mov dx,Lptx+2
    mov al,0    
	out dx,Al	
 }
}       
void Initialise (int Lptx)
{
 __asm
 {      
 
    mov dx,Lptx     
    mov al,0    
	out dx,Al     
	mov dx,Lptx+1    
    mov al,0    
	out dx,Al
	mov dx,Lptx+2    
    mov al,255    
	out dx,Al      

 }
}
                        
int LectAdc7896(int Lptx)
{  
     __asm {  
    cli
	mov dx,Lptx
    mov al,0        
	out dx,Al	
    nop                  
    nop
    mov al,2      
    out dx,Al
    inc dx
	nop
tbus:
    in al,dx
	test al,128
    jnz tbus       

	dec dx
    mov cx,2048
    
    mov bx,0 
    mov al,3       
    out dx,al
    mov al,2      
    out dx,al
    mov al,3      
    out dx,al
    mov al,2       
    out dx,al
    mov al,3       
    out dx,al
    mov al,2      
    out dx,al
    mov al,3      
    out dx,al
    mov al,2     
    out dx,al

L0:
    mov al,3      
    out dx,al
    inc dx         
    in al,dx       
    dec dx        
    test al,128
    jnz L1
	or bx,cx
 L1:
    mov al,2       
    out dx,al
    shr cx,1
    jnc L0
    mov al,0
	out dx,al
    mov ax,bx       
    and ax,3FFFh
    sti
   	} ;        
   return(counts);
 }      
                        
 int Lecture200LTC1286 (int Lptx)
{ 
  __asm 
  {         
    Align 2
    push ds
    push di 
    mov ds,Table
      
    mov dx,Lptx 
    cli
    mov al,0       ;cs1=0  => selection boitier, clock=0
	out dx,Al	; 1 er front descendant   
 	mov cx,2048   ; 2 ^11  car bit 0 a bit 11 => 12 bits 
 	mov bx,0
L00:
	push bx
    mov bx,0       ;init mesure a 0
    mov al,1       ;cs1=0  clock=1 ,   pulse numero 1
	out dx,al
    nop
    mov al,0       ;cs1=0  clock=0     2eme front descendant
	out dx,al
    nop
    mov al,1       ;cs1=0  clock=1 ,   pulse numero 2
	out dx,al
    nop
    mov al,0       ;cs1=0  clock=0     3eme front descendant
	out dx,al
    nop
    mov al,1       ;cs1=0  clock=1 ,   pulse numero 3
	out dx,al

L0:
    mov al,0       ;cs1=0  clock=0     4eme front descendant
	out dx,al
    inc dx         ; positionne @ Port sur LPTX+1
    in al,dx       ; lecture Busy @ Port LPTX+1
    dec dx         ; repositionne DX sur LPTX
    test al,128
    jnz L1
	or bx,cx
 L1:
    mov al,1       ; cs1=0  clock=0 , etat bas
	out dx,al
    shr cx,1
    jnc L0

    mov al,2         ; cs1=1 Hi Z ,clock=0
	out dx,al
    mov ax,bx        ; retour mesure      
    pop bx
    mov word ptr [bx],ax 
    inc bx 
    cmp bx,4
    jbe L00  
    sti
    mov Etat,bx
    pop di   
    pop ds
    }            
  return(Etat);
}
       
       
                      
                        
 int LectAdcLTC1286 (int Lptx)
{
 __asm
 {             
   
    ALIGN 2
    mov dx,Lptx
    cli
    mov al,0       ;cs1=0  => selection boitier, clock=0
	out dx,Al	; 1 er front descendant
 	
    mov cx,2048   ; 2 ^11  car bit 0 a bit 11 => 12 bits
    mov bx,0       ;init mesure a 0
    mov al,1       ;cs1=0  clock=1 ,   pulse numero 1
	out dx,al
    nop
    mov al,0       ;cs1=0  clock=0     2eme front descendant
	out dx,al
    nop
    mov al,1       ;cs1=0  clock=1 ,   pulse numero 2
	out dx,al
    nop
    mov al,0       ;cs1=0  clock=0     3eme front descendant
	out dx,al
    nop
    mov al,1       ;cs1=0  clock=1 ,   pulse numero 3
	out dx,al

L0:
    mov al,0       ;cs1=0  clock=0     4eme front descendant
	out dx,al
    inc dx         ; positionne @ Port sur LPTX+1
    in al,dx       ; lecture Busy @ Port LPTX+1
    dec dx         ; repositionne DX sur LPTX
    test al,128
    jnz L1
	or bx,cx
 L1:
    mov al,1       ; cs1=0  clock=0 , etat bas
	out dx,al
    shr cx,1
    jnc L0

    mov al,2         ; cs1=1 Hi Z ,clock=0
	out dx,al
    mov ax,bx        ; retour mesure
    mov counts,ax 
    sti
    }            
  return(counts);
}
 
// * Pauses for a specified number of microseconds. 
void sleep( clock_t wait )
{
   clock_t warte;
   warte = wait + clock();
   while( warte > clock() ) ;
}
 
 

void main()
{              
 float total=0.0;
 int mini=4096;
 int maxi=0;
 float Volt=0.0;
 float moyenne=0.0;
 double ecart=0.0;
 Tampon=(char *)malloc(80);  
 cout << " Version 02/08/95  Visual C++ 1.5 Lecture ADC 12 bits LTC1286 sur port LPTx"<< endl;

 /*
 cout << "disque : "  ;
 cin.get (Nom,3);
 if (GetDiskFreeSpace(Nom,SectCluster,MotSect,ClustLib,Clusters)==TRUE)
 {
  cout << "Secteur par cluster : " << dec << SectCluster << endl;
  cout << "Mot par secteur     : " <<  MotSect << endl; 
  cout << "Custers libres      : " <<  CustLib << endl;    
  cout << "Custers             : " <<  Clusters<< endl;  
 }                                                     
*/ 
 Lptx=0x278;   
 cout << " Adresse du port I/O (632=LPT2 888=LPT1) : ";
 cin.get(Tampon,4);  
 Lptx=atoi(Tampon);   
 Initialise(Lptx);
 AutoFeedOn(Lptx);
 cout << " Lptx=" << dec << Lptx << " soit " << hex << Lptx <<"H"<< endl;
 TDebut=clock();   
 counts= LectAdcLTC1286 (Lptx);
 ptr=Table;                
 i=0;
 while(i<=MaxiBoucles)
 {
	 counts= LectAdcLTC1286 (Lptx);   
	 *(ptr)=counts;
	 ptr++; i++;    
	
 }	 
 TFin=clock();
 total=0;
 ptr=Table;
 i=0;
 while(i<=MaxiBoucles)
 {               
     counts=*(ptr); 
     if (counts<=mini) mini=counts;
	 if (counts>=maxi) maxi=counts;
 	 total=total+(float) counts ;   
     ptr++;i++;
   }       
 ptr--;
 setprecision(3);
 moyenne=total/MaxiBoucles;
 cout.width(10); 
 setiosflags(ios::left);     
  i--;
   cout << endl;
   cout << " Nb mesures : "<< dec << i << endl;
   cout << " Mesure maxi    = "<< dec << maxi << "   "<<hex << maxi << "h" << dec <<endl;
   cout << " Mesure moyenne = "<< dec << moyenne <<   endl;  
   cout << " Mesure mini    = "<< dec << mini << "   " << hex << mini <<"h"<< dec << endl;  
   cout << endl;
   cout << " Temps depart = "<< dec<< TDebut << endl;
   cout << " Temps fin = " << TFin << endl;
   ecart=(double) (TFin-TDebut)*1000 /CLOCKS_PER_SEC ;  
   cout << " Ecart temps  = " << ecart <<" ms  pour lire "<< MaxiBoucles<< " chantillons" <<  endl<< endl;
   ecart=ecart*1000/MaxiBoucles;
  
    ptr=Table;
    i=0;                
  while(i<=10)
  {
	 counts=*(ptr);
	 cout << " mesures : "<< dec << i << "= " << counts << endl; 
	 ptr++;i++;
 }	     
   cout << endl; 
   cout << " Echantillonage 1 mesure en : " << ecart <<" s" <<  endl;    
   cout << endl; 
  
// --- suivre -------------------------------------
  
//  cout << " Usage subroutine Lecture200LTC1286"  << endl;
//  TDebut=clock();   
//  Etat=Lecture200LTC1286(Lptx);
//  TFin=clock();
//	total=0;
//	i=0;
//   	ptr=Table;                
//  	while(i<=10)
//  	{
//	 counts=*(ptr);
//	 cout << " mesures : "<< dec << ptr << "= " << counts << endl; 
//	 ptr++;i++;
// 	}
//   cout << " Retour Etat = "<< dec<< Etat << endl;
//   cout << " Temps depart = "<< dec<< TDebut << endl;
//   cout << " Temps fin = " << TFin << endl;
//   ecart=(double) (TFin-TDebut)*1000 /CLOCKS_PER_SEC ;  
//   cout << " Ecart temps  = " << ecart <<" ms  pour lire "<< MaxiBoucles<< " chantillons" <<  endl<< endl;
//   ecart=ecart*1000/MaxiBoucles;
//   cout << " Echantillonage 1 mesure en : " << ecart <<" s" <<  endl; 
   Initialise(Lptx);    
       
 }