#include "windows.h"

// P.FREYER 24/02/97
 
int donnee;
int counts;  
float Degres; 
float nbpoints=4096;
float ref=401;
char Auteur[]="P.FREYER";

int LibMain(HANDLE hModule,WORD wDataSeg,WORD cbHeapSize,LPSTR lpszCmdLine)
{
 return (1);
}
             


int PASCAL __export INPORTB (int Lptx)
{      
 __asm{
	mov dx,Lptx
	in al,dx  
	mov ah,0 
	mov donnee,ax 
	};     
	return(donnee);
}

void PASCAL __export OUTPORTB (int Lptx,int Value) 
{
 __asm {  
	mov ax,Lptx   
	mov dx,ax
	mov ax,Value 
	out dx,al
	};
}	
//voir C_AD7896.ASM
    // (c) PF 04 aout 95   rev1    mai 96
	// parametre LPTx
	// En Sortie: 1 mesure de tension par adc LTC1286
	//            format 12 bits pour 4.01V echelle
	//			 pour SCOPE_95.c version 1 voie
	//	 Hardware:     	entree analogique					Dip8 1
	//					masse analogique                    	 6
	//				   	2=D0 = sortie clock                      4
	//	               	3=D1 = sortie selection boitier			 7
	//	               	11=BUSY= entree pour lecture bit         5
	//				   	14=AUTO FEED = sortie pour alim montage  2
	//				   	10=ACK=status ADC						 8
	//				   	25=Masse logique                         2
	// 	 		alim stabilise via ZTR 4001                      
	//			mesure de temperature via LM35DZ 10mV/C 
                                                          
 

int PASCAL __export LectAdc(int Lptx)
{   
  __asm {
    cli
	mov dx,Lptx
    mov al,0        
	out dx,Al	
    nop                  
    nop
    mov al,2      
    out dx,Al
    inc dx
tbus: 
    in al,dx
	test al,64
    jnz tbus       

	dec dx
    mov cx,2048
    
    mov bx,0 
    mov al,3       
    out dx,al
    mov al,2      
    out dx,al
    mov al,3      
    out dx,al
    mov al,2       
    out dx,al
    mov al,3       
    out dx,al
    mov al,2      
    out dx,al
    mov al,3      
    out dx,al
    mov al,2     
    out dx,al

ICI:
    mov al,3      
    out dx,al
    inc dx         
    in al,dx       
    dec dx        
    test al,128
    jnz LABAS
	or bx,cx
LABAS:
    mov al,2       
    out dx,al
    shr cx,1
    jnc ICI
    mov al,0
	out dx,al
    mov ax,bx       
    and ax,3FFFh     
    mov [counts],ax 
    sti
    } ;
  
   return(counts);
 }      
    
float PASCAL __export Temperature(int Lptx)
{
  __asm {
    cli
	mov dx,Lptx
    mov al,0        
	out dx,Al	
    nop                  
    nop
    mov al,2      
    out dx,Al
    inc dx
tbus2:
    in al,dx
	test al,64
    jnz tbus2       

	dec dx
    mov cx,2048
    
    mov bx,0 
    mov al,3       
    out dx,al
    mov al,2      
    out dx,al
    mov al,3      
    out dx,al
    mov al,2       
    out dx,al
    mov al,3       
    out dx,al
    mov al,2      
    out dx,al
    mov al,3      
    out dx,al
    mov al,2     
    out dx,al

ICI2:
    mov al,3      
    out dx,al
    inc dx         
    in al,dx       
    dec dx        
    test al,128
    jnz LABAS2
	or bx,cx
LABAS2:
    mov al,2       
    out dx,al
    shr cx,1
    jnc ICI2
    mov al,0
	out dx,al
    mov ax,bx       
    and ax,3FFFh     
    mov [counts],ax 
    sti
 }
 return (float)counts * ref / nbpoints;
}    
