/*
 (C) P.FREYER.
fichier projet: SCOPTL94.prj
----------------
c:\tc\obj\TRIPF.obj
c:\tc\obj\SANSF.obj    <- integres dans C0C.lib
c:\tc\obj\EGAVGAF.obj
c:\tc\obj\CGAF.obj
--------------------
c:\tc\obj\C_TL5494.obj
c:\tc\scope\Scoptl94.c
-----------------
LINKER : case sensitiv off

Evolutions ou corrections :
- 20/09/94 modif limite POSITION  MAXPOSITION-400
- bizarre au niveau de la taille des fichiers ecrits...??
*/

#ifndef __COMPACT__
#error Mode COMPACT seulement....
#endif
#ifdef __COMPACT__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <graphics.h>
#include <alloc.h>
#include <Dos.h>
#include <Bios.h>
#include <fcntl.h>
#include <io.h>
#include <dir.h>

#define SIGLE TITRE(" SCOPE TL94  ",350,25,3,11,1);
char CopyRight[]="(c)P.Freyer 1994";
char Version[]={"Scoptl94.c 04mai94"};
#define CR printf("\n");

#include "c:\tc\scope\enregist.scp"

typedef enum {FALSE,TRUE} bool;
typedef unsigned char byte;
typedef unsigned int word;

struct REGPACK Rg;
union REGS Re,Rs;
char Interface[]="1 voie TL549I 8 bits";
char  * pCarte;
char  * TamponD;
char  * TamponH;
char  * BdT;
char  * BdF;
byte  * Mes;
byte  * Mesure;

FILE  * f1;
static char Nom_Fichier[]="SANSNOM.DAT";
extern _fmode;

typedef char fichier[40];
fichier  * Table_Fichier;
struct ffblk ff;

struct FN
{ char Name[8];
  char At[4];
};
struct FN * entite;
char  * Format;
char  * Nom;
char  * masque;
char  * Tampon;
char  * p;

typedef int maskmouse[32];
maskmouse far *curs;

static maskmouse  HANDARROW =
  { 0xC7FF,  0xC7FF,  0xC7FF,  0xC7FF,  0xC7FF,  0xC01F,  0xC01F,  0xC01F,
    0x001F,  0x001F,  0x001F,  0x001F,  0x001F,  0x001F,  0x001F,  0x001F,
    0x0000,  0x1000,  0x1000,  0x1000,  0x1000,  0x1000,  0x1540,  0x1540,
    0x1540,  0x5FC0,  0x5FC0,  0x7FC0,  0x7FC0,  0x7FC0,  0x7FC0,  0x0000 };

static maskmouse  CURSORARROW =
  { 0xFFFF,  0x9CFF,  0xEBFF,  0xF7FF,  0xF7FF,  0xF7FF,  0xF7FF,  0xF7FF,
    0xF7FF,  0xEBFF,  0x9CFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,  0xFFFF,
    0x0000,  0x0000,  0x0000,  0x0000,  0x0000,  0x0000,  0x0000,  0x0000,
    0x0000,  0x0000,  0x0000,  0x0000,  0x0000,  0x0000,  0x0000,  0x0000 };

static maskmouse  CROSSARROW =
{   0xFEFF,  0xFEFF,  0xFEFF,  0xFEFF,  0xFEFF,  0xFEFF,  0xFEFF,  0x0000,
    0xFEFF,  0xFEFF,  0xFEFF,  0xFEFF,  0xFEFF,  0xFEFF,  0xFEFF,  0xFFFF,
    0x0100,  0x0100,  0x0100,  0x0100,  0x0100,  0x0100,  0x0100,  0xFFFF,
    0x0100,  0x0100,  0x0100,  0x0100,  0x0100,  0x0100,  0x0100,  0x0000};

static maskmouse  QUESTARROW =
{   0xFFFF,  0xFE7F,  0xFC3F,  0xFC3F,  0xF81F,  0xF81F,  0xF00F,  0xF00F,
    0xE007,  0xE007,  0xC003,  0xC003,  0x8001,  0x8001,  0x0000,  0x0000,
    0x0000,  0x0000,  0x0000,  0x0180,  0x0180,  0x03C0,  0x0240,  0x0420,
    0x05A0,  0x0FB0,  0x0E30,  0x1E78,  0x1FF8,  0x3E7C,  0x3FFC,  0x0000};

word  *RbT;       /* Ram Bios Timer */

byte LgCsH=30;
byte LgCsV=24;
byte c,c0,c1,c2,c3;
byte Nbl;
byte Pg;
byte SampleSpeed; /*  60 pour 20Khz,120 pour 10Khz,239 =5Khz */
byte etatLP;

#define MaxFic 23

long MaxiPosition;
word Position;
int Vitesse,Balayage,MiniBalayage,MaxiBalayage;
word Duree_Point;
word Duree_M;
word MicroDelai;
word y1,y2;
word vieilY1,vieilY2;
word vieilX1,vieilX2;
word Mxi,Mni;
word MaxDX,MaxDY,MinDX,MinDY;
word Taille;
word Taillex,Tailley;
word i,j,k,l,m;
word Indice;
word Adresse;
word Seg1,Seg2;
word Nbcar;

void  * Poussoir;
void  * Glissiere;
void  * BpMarche;
void  * BpArret;
void  * Un_Ligne;
void  * Deux_Ligne;
void  * Un_Colonne;
void  * Deux_Colonne;

bool AfficheVolt;
bool AffichePeriode;
bool Power;
bool DrpDirect;
bool DrpMemory;
bool DrpBdT;
bool DrpHardcop;
bool DrpFile;
bool DrpAcquis;
bool Calibration;
bool Encore;

float COEF;
float Volt,A_Volt,B_Volt,Moy;
float Periode,A_Periode,B_Periode;
float Freq;
float Ecart,Beg,fini;
float SeuilTrigger;
float t;
float Pas_Lift;
float Pos_Lift;

int ADC;
int Gauche,Droite,Milieu,x,y;
int Status,Bouton,Ap;
int MouvementX;
int Seuil;
int CarteGraphique;
int ModeGraphique;
int Etat;

int DrpMarq;
int Frappe;
int done,Attr;
int Maxi_Fichiers=200;
int ErrorCode;
int MaxX,MaxY;
int x,y,x0,y0,rx,ry;
int Ex0,Ex1,Ey0,Ey1;
int Ymax,Ymin,Xmax,Xmin;
int CountBouton;
int Vieuxy,Vieuxx;
int LargBp,HautBp;

long xD,xF,xE;
long Fichier_Lu;

#define Zone_Trace_Grafe (x>MinDX)&&(x<MaxDX)&&(y>MinDY)&&(y<MaxDY)
#define Zone_Reglage_Trigger (x<120) && (x>80) && (y>64) && (y<265)
#define Zone_Position (y>370)&&(x>362)&&(x<446)&&(y<388)
#define Zone_Balayage (x>534)&&(x<590)&&(y<388)
#define Zone_BP       (Bouton>0)&&(x<44)&&(x>29)
#define Zone_Choix_Fichier (y>MinDY+24)&&(y<MaxDY-10)&&(x>MinDX+10)&&(x<MaxDX-2)

#define Bp_Memory 270
#define Bp_Hardcop 150
#define Bp_File 210
#define Bp_Direct 330
#define Bp_Print 90
#define Bp_Power 402

/* specifique au TL5491 AD 8bits serie  sur LPTx:
  etat D0  => 0 ou 1   pour clock
  etat D1  => 0 ou 2   pour selection boitier
  etat ACK => 0 ou 64  pour lecture bit
  pour utilisation en 100% LANGAGE C
*/
#define ADC_Wr      ADC
#define ADC_Rd	    ADC+1
#define ChipsUnSelect outportb(ADC_Wr,6)
#define ClockON     outportb(ADC_Wr,5)
#define ClockOFF    outportb(ADC_Wr,4)
#define ReadADC     inportb(ADC_Rd)&64
#define Strobe 		ChipsUnSelect;k=128;l=0;
#define Acquis for(i=0;i<8;i++){\
				ClockON;\
				j=ReadADC;\
				ClockOFF;\
				if (j==64)l=l+k;\
				k=k>>1;\
				};\
				Mesure[Indice++]=l;\
				ChipsUnSelect;

/* ---------------- PROTOTYPES DE FONCTIONS --------------------*/

extern int TL5494(int ADC);     /* use C_TL5494.obj :get 1 mesure sur ADC */

void Presentation();
void interrupt Traitement_1C();
void Restore_1C();
static void Setup_Divisor(word Div);
void AdjustMicroDelai();
void Delai_uS(int jjj);			/* Delai exprim en S */
void Delai(int jjj);			/* Delai exprim en Milllisecondes */
void Pause(char c);
void Couine();
void Boof();
void Burp();
void Rideau();
void InitGraf();
void StateLp();
void Print_Out_Values();
void HMS();
int  JMA();
void Entete_Lp();
void Lp(char c);             /* emission d'un car sur LP */
void Hardcopy();
void TITRE(char *Tampon,int x,int y,int h,int Couleur,int Ap);
void Rivet(int x,int y,int r);
void Support_Bp();
void BpChoix(int jk);
void Mise_Hors_Tension();
void Uncal(bool i);
void BoiteDialogue(int color);
void AffichageValue(int i,word v,int L);
void MoveGrafePosition();
void EcrisFichier();
long LisFichier();
float Extrait_Le_Nom(int j);
void Rafraichit_Liste_Fichiers(int j);
char Choix_Liste_Fichier();
void ACQUISITION();
void Enregistrement();
void Ultra_Speed_Acquisition();
void Temps_reel_Acquisition();
void Triggered_Acquisition_Directe();
void interrupt (*OldInt1C)(void);
void InitSouris(int i);
void DXsouris (int Xmin,int Xmax);
void DYsouris (int Ymin,int Ymax);
void EtatSouris();
int  DeplaceSouris (int x,int y);
void PresseSouris(int Bouton);
void RelacheSouris(int Bouton);
void PopSouris();
void PushSouris();
void FormeSouris (int F);
/* ------------------------------------------------*/

void FormeSouris (int F)
{
  int i,j;
  union REGS regs;
  struct SREGS sregs;
  PushSouris();
  switch (F)
   { case 1:
        curs= &HANDARROW;
	i=5;j=5; break;
     case 2:
     	curs= &CURSORARROW;
	i=4;j=6; break;
     case 3:
        curs= &CROSSARROW;
	i=8;j=8; break;
     case 4:
        curs= &QUESTARROW;
	i=0;j=8; break;
     default:
      curs= &CROSSARROW;
      i=0;j=0;
   }
  regs.x.ax=9;
  regs.x.cx=i;
  regs.x.bx=j;
  regs.x.dx=FP_OFF(curs);
  sregs.es=FP_SEG(curs);
  int86x(0x33,&regs,&regs,&sregs);
  PopSouris();
}


void InitSouris(int i)
{
Re.x.ax=0;
int86(0x33,&Re,&Rs);
Status=Rs.x.ax;
Bouton=Rs.x.bx;
printf("\nInit Souris\n Status  =%3d  Bouton= %5d",Status ,Bouton);
if (Status !=-1)
{
 printf("\n Attention..Pb :souris NON initialise");
 sleep(2);
 nosound();
 sound(1000);
 sound(200);
 sleep(1);
 nosound();
 if (i==1) exit(Status);
 }
}

void DXsouris (int Xmin,int Xmax)
{
Re.x.ax=7;Re.x.cx=Xmin;Re.x.dx=Xmax;
int86(0x33,&Re,&Rs);
}

void DYsouris (int Ymin,int Ymax)
{
Re.x.ax=8;Re.x.cx=Ymin;Re.x.dx=Ymax;
int86(0x33,&Re,&Rs);
}

void EtatSouris()
{
Re.x.ax=3;
Gauche=0;Droite=Milieu=0;
int86(0x33,&Re,&Rs);
Bouton=Rs.x.bx;
Gauche=(Rs.x.bx & 1);
Droite=(Rs.x.bx & 2);
if (Bouton>=3) Milieu=1; else Milieu=0;
x=Rs.x.cx;y=Rs.x.dx;
}


int DeplaceSouris (int x,int y)
{
Re.x.ax=4;Re.x.cx=x;Re.x.dx=y;
int86(0x33,&Re,&Rs);
}

void PresseSouris(int Bouton)
{
Re.x.ax=5;Re.x.bx=Bouton;
int86(0x33,&Re,&Rs);
Bouton=Rs.x.ax;
Gauche=(Rs.x.ax & 1);
Droite=(Rs.x.ax & 2);
if (Bouton>=3) Milieu=1; else Milieu=0;
CountBouton=(Rs.x.bx);
x=Rs.x.cx;y=Rs.x.dx;
}

void RelacheSouris(int Bouton)
{
Re.x.ax=6;
Re.x.bx=Bouton;
int86(0x33,&Re,&Rs);
Bouton=Rs.x.ax;
Gauche=(Rs.x.ax & 1);
Droite=(Rs.x.ax & 2);
if (Bouton>=3) Milieu=1; else Milieu=0;
CountBouton=(Rs.x.bx);
x=Rs.x.cx;y=Rs.x.dx;
}

void PopSouris()
{
 Re.x.ax=1;
 int86(0x33,&Re,&Rs);
}

void PushSouris()       /* enleve fleche */
{
Re.x.ax=2;
int86(0x33,&Re,&Rs);
}

void Presentation()
{
textcolor(7);
cprintf(" Ŀ");
#ifdef NOTREGISTERED
printf("\n  ");
textcolor(12);
cprintf("Distribution SHAREWARE");
textcolor(7);
cprintf("                                                   ");
#endif
printf("\n  Nom    : SCOPTL94.C        DOS     :  6.20   Video : VGA 640x480 16c     ");
printf("\n  Date   : V0.10/91          Materiel:  E.E.T. 486DXII 66Mhz ,LPTx         ");
printf("\n  Auteur : P.FREYER          Langage :  Turbo C Version 2.0                ");
printf("\n  Derniere MAJ :04/05/94     Souris  :  OUI indispensable (2 ou 3 boutons!)");
printf("\n ");
printf("\n");
  printf(" Ŀ");
printf("\n  But       :");
textcolor(10);
cprintf(" Simulation d'Oscilloscope  mmoire numrique .");
textcolor(7);
printf("              ");
printf("\n * New Hard : TL5491 ADC 8 bits serie sur ACK LPtx  =1 C.I. 8 broches      ");
printf("\n  Echantillonage maxi 98S non Calibr soit limite soft de srialisation   ");
printf("\n  TL5491 Entre 0  5V sortie sur 1 bit envoy sur l'entre ACK  LPTx      ");
printf("\n  BALAYAGE : (98S non cal)  250S  20mS par point en mode INTERRUPTION. ");
printf("\n  * resultats obtenu sur un 386 SX 16 Mhz ....                             ");
printf("\n  SENSIBILITE : 0  5V sur 8 bits, TRIGGER 0  5V                         ");
printf("\n  FICHIER de stockage sur 60000 valeurs + 2 octets dfinissant la priode.");
printf("\n  ACCES A TOUTES LES COMMANDES VIA SOURIS ( lancer xxMOUSE.com avant..)   ");
printf("\n ");
CR
CR
y=wherey();
Pause(13);
gotoxy(1,y);delline();
#ifdef NOTREGISTERED
sleep(3);
#endif
clrscr();
printf("\n");
printf("\n  ");
textcolor(14);
cprintf("News 93 &    94");
textcolor(7);
cprintf("Ŀ");
printf("\n * Partie mesure en ASM,pour prparer par la suite la banalisation MESURE  ");
printf("\n * Passage adresse Port Lecture ADC au Sous Prog. ASSEMBLEUR               ");
printf("\n * New Gestion souris                                                      ");
printf("\n * Mars 93 Bug sur SP ASM MaMesure...=> comportement etrange de la souris  ");
printf("\n   en mode UNCAL ............                                              ");
printf("\n * 01/94 TEST Avec 486DXII 66Mhz : 46S en mode UNCAL !!!                  ");
printf("\n * 05/94 Utilisation du S.P.ASM => C_TL5494.obj resultat correct mais      ");
printf("\n    delai inter-mesure a respecter !!!                                     ");
printf("\n ");
CR
textcolor(14);
CR
y=wherey();
Pause(13);
gotoxy(1,y);delline();
#ifdef NOTREGISTERED
sleep(3);
#endif
CR
#ifdef NOTREGISTERED
textcolor(10);
cprintf("Une contribution de 50F est demande pour l'usage des logiciels SCOPExx");
CR
cprintf("et en option : +115F pour obtenir des renseignements techniques et les");
CR
cprintf("sources *.ASM (partie Mesure),les sources TC V2.0 des versions 92,");
CR
cprintf(" SCOPTL93.C SCOP7575.c ainsi que SCOPE_2V.OBJ pour re-linkage .");
CR
cprintf("qui seront alors dlivrs pour un usage ");
textcolor(12);
cprintf(" STRICTEMENT PERSONEL et INDIVIDUEL");
textcolor(2);
cprintf(".");
CR
CR
#ifdef NOTREGISTERED
sleep(3);
#endif
y=wherey();
Pause(27);
gotoxy(1,y);delline();
#endif
textcolor(7);
cprintf(".");
clrscr();
}

void interrupt Traitement_1C()
{
Mesure[Indice]=(char)TL5494(ADC);
Indice++;
/* pour 100% en C
	Strobe
	Acquis
*/
}

void Restore_1C()
{
disable();
 outportb(0x43,0x36);	/* acces timer 2 du 8253 en Mode 1   lect/ecr LSB*/
 outportb(0x40,0xFF);	/* remet le diviseur d'origine LSB timer 2 */
 outportb(0x40,0xFF);	/* MSB timer 2  soit : 65535 => 18,2 int/sec */
 setvect(0x1c,OldInt1C);
enable();
}

static void Setup_Divisor(word Div)
{
word cnt;
int lo,hi;
disable();
Periode=1.192180*Div;
cnt=(word) Periode;
lo=(byte) (cnt % 0x100);
hi=(byte) (cnt /0x100);
outportb(0x43,0x36);
outportb(0x40,lo);
outportb(0x40,hi);
enable();
}

void Pause(char ccc)
{
char c1;
 if (ccc>32)
  {
  printf("Appuyer sur <%c> ",ccc);
  }
  else
  {
   switch (ccc)
   {
   case 27:
   printf("Appuyer sur <ESC> ");
   break;
   case 13:
   printf("Appuyer sur <RETURN>");
   break;
   default:
   printf("Appuyer sur une Touche");
   break;
   }
 }
 c1=0;
 while((c1!=ccc)&&(c1!=27))
 {
 if (kbhit()) c1=getch();
 if (c1>96) c1=c1-32;
 }
}

void AdjustMicroDelai()
{
  long i;
  printf("\nPatience...calcul microdelai sur 10 000 000 de boucles  while..");
  xD=*(RbT)+*(RbT+2)*65535;
  i=0;
  while(i<10000000)i++;
  xF=*(RbT)+*(RbT+2)*65535;
  xE=xF-xD;         			/* duree en 1/18 eme de secondes */
  Ecart=(1000000.0*xE)/18.2;    /* duree en microsecondes */
  MicroDelai=(unsigned int)(Ecart/1000.0);
  printf("\nXd=%10ld \nXF=%10ld \nXE=%10ld\
	\nEcart=%12.3f S pour 10 000 000 de boucles\
	\nMicroDelai pour 10000 boucles =%8d\
	\nDuree de une boucle=%6.6f S",\
	xD,xF,xE,Ecart,MicroDelai,Ecart/10000000);
  if (MicroDelai>10000) MicroDelai=1; else MicroDelai=10000/MicroDelai;
  printf("\nMicroDelai de base =%8d pour 1 S",MicroDelai);
}

void Delai_uS(int jjj)     		 /* Delai exprim en S */
{
 int iii;
 iii=MicroDelai;
 if (jjj>30)
 {
  do
  {
  while(iii>0)iii--;
  jjj--;
  }while (jjj>0);
 }
}

void Delai(int jjj)   			/* Delai exprim en Milllisecondes */
{
int iii;
iii=MicroDelai*1000;
while (jjj>0)
 {
 while (iii>0)iii--;
 jjj--;
}
}

void Couine()
{
int i,iii;
for (i=100;i<500;i=i+10)
{ sound(i); for (iii=0;iii<20000;iii++); nosound();}
nosound();
}

void Boof()
{
int i;
for (i=500;i>100;i=i-50)
{
sound(i);Delai(5);
}
nosound();
}

void Burp()
{ sound(300);
  Delai(100);
  nosound();
}

void Rideau()
{
 setcolor(0);
 for (i=0;i<=320;i++)
  {
   sound(480-i);
   line(i,0,i,480);
   line(640-i,0,640-i,480);
  }
  Delai(5);
  nosound();
  gotoxy(10,10);
  printf("Fin Normale de programme..........");
  sleep(1);
  closegraph();
#ifdef NOTREGISTERED
  clrscr();
  textcolor(12);
  gotoxy(1,6);
  cprintf("Version NON ENREGISTREE...");
  Couine();
  CR
  sleep(4);
#else
#include "c:\tc\scope\USER_sc.txt"
#endif
}

void InitGraf()
{
 printf("\nInitgraf.c");
 CarteGraphique=DETECT;
 if(registerfarbgifont(triplex_font_far) < 0)
  {
   Couine();
   printf("\nPb font TRIP non integree ..");
   sleep(2);
   exit(1);
   }
   else
    printf("\nintegration ....Font TRIP");
 if (registerfarbgifont(sansserif_font_far)<0)
   {
   Couine();
   printf("\nPb font SANS non integree ..");
   sleep(2);
   exit(1);
   }
   else
    printf("\nintegration..... Font SANS");
 if (registerfarbgidriver(EGAVGA_driver_far )<0)
  {
   Couine();
   printf("\nPb Driver EGAVGA non integree ..");
   sleep(2);
   exit(1);
   }
   else
      printf("\nintegration .....Driver EGAVGA");
 sleep(1);
 initgraph (&CarteGraphique,&ModeGraphique,"");
 ErrorCode=graphresult();
 if (ErrorCode!=grOk)
  {
  printf("erreur initialisation Grafique :%s \n",grapherrormsg(ErrorCode));
  sleep(2);
  exit(1);
  }
 MaxX=getmaxx();
 MaxY=getmaxy();
 printf("\nMax X= %5d      Max Y= %5d   ",MaxX,MaxY);
 #ifdef NOTREGISTERED
 sleep(3);
 #endif
 sleep(1);
 clearviewport();
}

void StateLp()
{
 etatLP=0;
 Re.h.ah=0x02;
 Re.x.dx=0x0000;
 int86(0x17,&Re,&Rs);
 etatLP=Rs.h.ah;
 if(etatLP==144 ) etatLP=1; else etatLP=0;
 }

void Print_Out_Values()
{
unsigned word x,i,k1,k2;
float v;
StateLp();
k1=vieilX1-MinDX+Position;
k2=vieilX2-MinDX+Position-1;
if ((k2>k1)&&(etatLP==1))
{
Entete_Lp();
sprintf(TamponD,"x1=%6d",k1); write(4,TamponD,9);Lp(10);Lp(13);
sprintf(TamponD,"x2=%6d",k2); write(4,TamponD,9);Lp(10);Lp(13);
if(sprintf(Tampon,"Duree x1 x2= %7.1f",Periode)==0) Couine();
strcat(Tampon,BdT+4);
write(4,Tampon,strlen(Tampon));Lp(10);Lp(13);
i=0;
for (x=k1;x<=k2;x++)
{
 if (i % 20==0)
  {
   Lp(13);Lp(10);
   sprintf(TamponD,"%6d> ",x);write(4,TamponD,9);
  }
 v=Mesure[x]*5.00/255; sprintf(TamponD,"%2.2f",v); write(4,TamponD,6);
 i++;
 }
 Lp(10);Lp(13);
 }
 else Boof();
}

void HMS()
{
  byte i,j,k;
  Re.h.ah =0x2C;	/* lecture de l'heure */
  Re.x.dx = 0;
  int86(0x21,&Re,&Rs);
  TamponH="          ";
  i=Rs.h.ch;
  j=Rs.h.cl;
  k=Rs.h.dh;
  sprintf(TamponH,"%2dH%2dM%2dS ",i,j,k);
  *(TamponH+10)=0;
 }

int JMA()
{
  byte i,j,k;
  Re.h.ah =0x2A;	/* lecture de l'heure */
  Re.x.dx = 0;
  int86(0x21,&Re,&Rs);
  i=Rs.h.dl;
  j=Rs.h.dh;
  k=Rs.x.cx-1900;
  sprintf(TamponD,"%2d/%2d/%2d ",i,j,k);
  *(TamponD+10)=0;
 }

void Lp(char c)
{
do {
  Re.h.ah=0;
  Re.h.al=c;
  Re.x.dx=0;
  int86(0x17,&Re,&Rs);
  }
  while((Rs.h.ah & 0x01) != 0);
}


void Entete_Lp()
{
 Lp(10);Lp(13);
 Lp(15); /* compress */
 JMA();HMS();
 write(4,TamponD,10);Lp(20);write(4,TamponH,10);Lp(10);Lp(13);
 write(4,Nom_Fichier,13);
 Lp(10);Lp(13);
 *(TamponD)=0;
 *(TamponH)=0;
}

void Hardcopy()
{
 int t,yt,x,y;
 int my;
 int Max,Min;
 float Moy;
 byte pr;
 StateLp();
 if (etatLP==1)
 {
 my=MaxDY+23;
 Entete_Lp();
 Moy=0.0;
 Max=0;Min=255;
 for (y=1;y<399;y++)
 {
  t=Mesure[y];
  Max=t>Max?t:Max;
  Min=t<Min?t:Min;
  Moy=Moy+t;
  }
  Moy=(Moy*5.00)/(400.0*256);
 sprintf(TamponH,"Moy=%2.3f",Moy);write(4,TamponH,10);Lp(10);Lp(13);
 Moy=Max*5.00/256;
 sprintf(TamponH,"Max=%2.3f",Moy);write(4,TamponH,10);Lp(10);Lp(13);
 Moy=Min*5.00/256;
 sprintf(TamponH,"Min=%2.3f",Moy);write(4,TamponH,10);Lp(10);Lp(13);
 Lp(10);Lp(13);
 Lp(27);Lp('1');	 /*    interligne 7/72  */
 y=MinDY-8;
 while(y<=my)
 {
 Lp(27);Lp('Y');Lp(224);Lp(1);		/*mode  120 points /pouce */
 /*  Lp(27);Lp('K');Lp(224);Lp(1);		 60 points /pouce */
   for (x=MinDX-16;x<639;x++)
   {
    yt=y;
    pr=0;
     for (t=0;t<8;t++)
     {
      pr=pr << 1;
      k=getpixel(x,yt);		/* exclusion noir,gris,blanc clair */
      if ((k!=0)&&(k!=8)&&(k!=7)) pr=pr|1;
      yt++;
     }
     Lp(pr);
   }
  y=yt;
  Lp(27);Lp('1'); /*    interligne 7/72  */
  Lp(10);Lp(13);
  }
  Lp(27);Lp('2');
  Lp(13);Lp(10);
 }
 else Boof();
}

void TITRE(char *Tampon,int x1,int y1,int h,int Couleur,int Ap)
{
int z;
settextjustify(CENTER_TEXT,CENTER_TEXT);
z=(h*8);
l=strlen(Tampon)*8*h;
setfillstyle(SOLID_FILL,8);
setcolor(2);
bar(x1-5-l/2,y1-5-z/2,x1+l/2+5,y1+5+z/2);
settextstyle(DEFAULT_FONT,0,h);
setcolor(Couleur);
outtextxy(x1+Ap*2,y1+Ap*2,Tampon);
if (y1<(5+z/2)) Couine();
setcolor(0);
setlinestyle(0,0,3);
if (Ap==0)
 rectangle(x1-5-l/2,y1-5-z/2,x1+l/2+5,y1+5+z/2);
 else
 {
 line(x1-5-l/2,y1-5-z/2,x1+l/2+5,y1-5-z/2);
 line(x1-5-l/2,y1-5-z/2,x1-l/2-5,y1+5+z/2);
 }
if (Ap==1) setcolor(0); else setcolor(15);
setlinestyle(0,0,1);
line(x1-5-l/2,y1-4-z/2,x1+l/2+5,y1-4-z/2);
line(x1-5-l/2,y1-5-z/2,x1-5-l/2,y1+5+z/2);
line(x1-5-l/2,y1-5-z/2,x1+l/2+5,y1-5-z/2);
line(x1-4-l/2,y1-5-z/2,x1-4-l/2,y1+5+z/2);
Taillex=l+10;
Tailley=z+10;
}

void Rivet(int x,int y,int r)
{
  setlinestyle(SOLID_LINE,0,3);
  circle(x,y,r);
  setfillstyle(SOLID_FILL,15);
  floodfill(x,y,0);
}

void Support_Bp()
{
setfillstyle(SOLID_FILL,7);
bar(57,398,146,420);
setfillstyle(SOLID_FILL,0);
bar(58,404,146,415);
setcolor(15);
line(58,415,146,415);
line(146,404,146,415);
line(58,404,58,415);
}

void BpChoix(int jk)
 {
 if (Power==FALSE) jk=1;
 *(Tampon)=0;
 switch (jk)
 {
  case 0:
    Support_Bp();
    strcpy(Tampon,"<>");
    TITRE(Tampon,71,408,1,10,0);
    AfficheVolt=TRUE;
    AffichePeriode=FALSE;
    DrpMarq=0;
    strcpy(Tampon," VOLTS  ");
    TITRE(Tampon,234,380,1,10,0);
    break;
  case 1:
    Support_Bp();
    strcpy(Tampon,"<>");
    TITRE(Tampon,100,408,1,10,0);
    AfficheVolt=FALSE;
    AffichePeriode=FALSE;
    DrpMarq=0;
    strcpy(Tampon,"       ");
    TITRE(Tampon,234,415,2,14,0);
    strcpy(Tampon,"        ");
    TITRE(Tampon,234,380,1,10,0);
    break;
  case 2:
    Support_Bp();
    strcpy(Tampon,"<>");
    TITRE(Tampon,130,408,1,10,0);
    AfficheVolt=FALSE;
    AffichePeriode=TRUE;
    DrpMarq=0;
    strcpy(Tampon," TIME   ");
    TITRE(Tampon,234,380,1,10,0);
    break;
  default:
    break;
  }
}

void AffichageValue(int i,word v,int L)
{
 *(Tampon)='\0';
 ltoa((long)v,Tampon,10);
 while (strlen(Tampon)<L) {strcat(Tampon," ");};
 setcolor(5);
 TITRE(Tampon,i,415,2,14,0);
 *(Tampon)='\0';
}

void MoveGrafePosition()
{
setfillstyle(SOLID_FILL,0);
bar (MinDX,MinDY,MaxDX,MaxDY);
setcolor(10);
moveto(MinDX,MaxDY-Mesure[Position]);
i=1;
do
 {
 lineto(MinDX+i,MaxDY-Mesure[Position+i]);
 i++;
 }
while (i<=400);
vieilX1=0xFFFF;
vieilX2=0xFFFF;
vieilY1=0xFFFF;
vieilY2=0xFFFF;
}

void BoiteDialogue(int color)
{
  setfillstyle(SOLID_FILL,color);
  bar(162,340,600,358); /* dialogue */
  setfillstyle(SOLID_FILL,0);
}

void Mise_Hors_Tension()
{
   DrpDirect=FALSE;
   DrpFile=FALSE;
   DrpMemory=FALSE;
   Power=FALSE;
   DrpAcquis=FALSE;
   DrpHardcop=FALSE;
   AfficheVolt=FALSE;
   AffichePeriode=FALSE;
   putimage(28,Bp_Power-HautBp,BpArret,COPY_PUT);
   putimage(28,Bp_Direct-HautBp,BpArret,COPY_PUT);
   putimage(28,Bp_Hardcop-HautBp,BpArret,COPY_PUT);
   putimage(28,Bp_File-HautBp,BpArret,COPY_PUT);
   putimage(28,Bp_Print-HautBp,BpArret,COPY_PUT);
   putimage(28,Bp_Memory-HautBp,BpArret,COPY_PUT);
   setfillstyle(SOLID_FILL,0);
   bar (MinDX,MinDY,MaxDX,MaxDY);
   setcolor(0);settextstyle(DEFAULT_FONT,1,1);
   outtextxy(18,Bp_Power,"Power");
   outtextxy(18,Bp_Direct," Direct ");
   outtextxy(18,Bp_File,"Fichier");
   outtextxy(18,Bp_Memory,"Memory");
   outtextxy(18,Bp_Hardcop,"HardCop");
   outtextxy(18,Bp_Print," Print ");
   strcpy(Tampon,"       ");
   *(Tampon+7)=0;
   TITRE(Tampon,234,415,2,14,0); /* valeur volt ou time */
   strcpy(Tampon,"      ");
   *(Tampon+6)=0;
   TITRE(Tampon,382,415,2,14,0); /* index */
   TITRE(Tampon,532,415,2,14,0); /* balayage */
   strcpy(Tampon,"     ");
   *(Tampon+5)=0;
   TITRE(Tampon,102,320,2,14,0);/* Seuil */
   BpChoix(1);
 }

void Uncal(bool i)
{
   setcolor(0);
   Calibration=i;
   strcpy(Tampon,"S/Pts <.  .>");
   *(Tampon+8)=17;*(Tampon+11)=16;
   TITRE(Tampon,530,380,1,11-i,0);  /* en Rouge !... */
   if(Calibration==FALSE)
   {
   setcolor(0);
   circle(614,372,8);
   setfillstyle(SOLID_FILL,4);
   floodfill(614,372,0);
   Duree_Point=9999;
   if(sprintf(Tampon,"%6d",Duree_Point)==0)Couine();
   setcolor(10);
   TITRE(Tampon,532,415,2,14,0);
   setcolor(7);settextstyle(DEFAULT_FONT,1,1);
   outtextxy(614,410,"Calib");
   setcolor(0);settextstyle(DEFAULT_FONT,1,1);
   outtextxy(614,410,"Uncal");
    }
    else
    {
    setcolor(0);
    circle(614,372,8);
    setfillstyle(SOLID_FILL,2);
    floodfill(614,372,0);
    setcolor(7);settextstyle(DEFAULT_FONT,1,1);
    outtextxy(614,410,"Uncal");
    setcolor(2);settextstyle(DEFAULT_FONT,1,1);
    outtextxy(614,410,"Calib");
   }
}

void EcrisFichier()
{
 long i;
 char * Bidon;
 Bidon=(char *)malloc(80);
 if (Bidon==NULL)
 {
 outtextxy(170,350,"Pb alloc memoire pour Bidon");
 Couine();
 return;
 }
 strcpy(Bidon,"DATAS");
 if (chdir(Bidon)!=0)
 {
  outtextxy(170,350,"Directory DATAS non trouv");
  Couine();
  free(Bidon);
  return;
 }
 f1=fopen(Nom_Fichier,"wr+b");
 if(f1==NULL)
 {
 gotoxy(25,5);
 printf("Probleme sur ecriture.......");
 Couine();
 }
  else
  {
  rewind(f1);
  i=fseek(f1,0,SEEK_SET);
  i=fwrite(Mesure,sizeof(char),MaxiPosition,f1);     /* Ecriture de Taille bytes */
  gotoxy(25,5);
  if (i==MaxiPosition)
	  printf("Ecriture reussie..de %8u octets.",i);
	  else
	   printf("PB Ecriture ................");
  sleep(1);
  i=fseek(f1,1,SEEK_END);
  i=fwrite(&Duree_Point,sizeof(int),1,f1); /* ecriture valeur Base de temps */
  fclose(f1);
  gotoxy(25,5);
  printf("Ecriture de echantillon= %6d    ..",Duree_Point);
  sleep(1);
 }
strcpy(Bidon,"..");
chdir(Bidon);
free(Bidon);
}

long LisFichier()
{
char *Bidon;
word i,i1;
Bidon=(char *)malloc(80);
if (Bidon==NULL)
{
outtextxy(170,350,"Pb alloc memoire pour Bidon");
Couine();
return(0);
}
strcpy(Bidon,"DATAS");
if (chdir(Bidon)!=0)
 {
  outtextxy(170,350,"Directory DATAS non trouv");
  Couine();
  free(Bidon);
  return(0);
 }
f1=fopen(Nom_Fichier,"r+b");
if (f1==NULL)
  {
  outtextxy(170,350,"fichier non trouv.");
  sleep(3);
  i=0;
  }
  else
  {
  rewind(f1);
  i1=fread(Mesure,sizeof(byte),MaxiPosition,f1);
  gotoxy(25,5);
  printf("Lecture reussie de %8u octets.",i1);
  sleep(1);
  fseek(f1,MaxiPosition,SEEK_SET);
  i=fread(&Duree_Point,sizeof(int),1,f1);
  fclose(f1);
  sleep(1);
 }
strcpy(Bidon,"..");
chdir(Bidon);
free(Bidon);
return(i1);
}

float Extrait_Le_Nom(int j)
{
  int i,jo,mo,an,he,mi,se;
  float t;
  i=strlen(ff.ff_name);
  strcpy(entite->Name,"        .   ");
  p=strchr(ff.ff_name,'.');
  strcpy(entite->At,p);
  strncpy(entite->Name,ff.ff_name,p-ff.ff_name);
  strcpy(Tampon,entite->Name);
  se=ff.ff_ftime & 0x001f;
  mi=(ff.ff_ftime >>5)& 0x003f;
  he=(ff.ff_ftime >>11)& 0x001f;
  jo=ff.ff_fdate & 0x001f;
  mo=(ff.ff_fdate>>5)& 0x000f;
  an=80+((ff.ff_fdate >>9)& 0x007f);
  t=(float)ff.ff_fsize;
  t=t/1000.0;
  sprintf(Tampon,"%-12s %2d/%2d/%2d %02d%02d  %3.1fK",entite->Name,jo,mo,an,he,mi,t);
  *(Tampon+36)='\0';
  strcpy(Table_Fichier[j],Tampon);
 return(t);
 }

void Rafraichit_Liste_Fichiers(int j)
{
 int i,k;
 Pos_Lift=Pas_Lift*(float)j;
 setfillstyle(CLOSE_DOT_FILL,1);
 bar(MaxDX-96,MinDY+23,MaxDX-68,MaxDY-1);
 setfillstyle(SOLID_FILL,9);
 bar(MaxDX-95,MinDY+23+Pos_Lift,MaxDX-69,Pos_Lift+MinDY+40);
 setfillstyle(SOLID_FILL,1);
 bar(MaxDX-93,MinDY+30+Pos_Lift,MaxDX-69,Pos_Lift+MinDY+40);
 setcolor(0);
 line(MaxDX-93,MinDY+30+Pos_Lift,MaxDX-69,Pos_Lift+MinDY+30);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 setfillstyle(SOLID_FILL,0);
 if(Maxi_Fichiers>=1)
 {
  for(i=0;i<=MaxFic;i++)
  {
  setcolor(7);
  bar(MinDX+1,MinDY+24+i*9,MaxDX-97,MinDY+32+i*9);
  if (j<MaxFic) strcpy(Tampon,Table_Fichier[i]); else strcpy(Tampon,Table_Fichier[j+i-MaxFic]);
  setcolor(12);
  outtextxy(MinDX+12,MinDY+32+i*9,Tampon);
  }
  }
  strcpy(Tampon,Table_Fichier[j]);
  if (j<MaxFic) k=j; else k=MaxFic;
  setcolor(14);
  outtextxy(MinDX+12,MinDY+32+k*9,Tampon);
}

char Choix_Liste_Fichier()
{
 int j;
 float Taille_Tot;
 char escape;
 escape=0;
 entite=(struct FN *)malloc(sizeof(struct FN));
 Table_Fichier=(fichier *) calloc(200,sizeof(fichier));
 if (Table_Fichier==NULL)
  {
  Couine();
  gotoxy(25,12);
  printf("Pb allocation : mmoire insuffisante.....");
  Couine();
  sleep(3);
  exit(27);
  }
 Fichier_Lu=0L;
 Attr=FA_ARCH;
 strcpy(masque,"DATAS\\*.dat");
 done=findfirst(masque,&ff,Attr);  /* Attr was 63 */
 Taille_Tot=0.0;
 j=0;
 if (done==0)
 {
 if ((ff.ff_attrib&Attr)==Attr) {Taille_Tot=Taille_Tot+Extrait_Le_Nom(j);j++;}
 while((!findnext(&ff))&&(j<200))
  {
  if((ff.ff_attrib&Attr)==Attr){Taille_Tot=Taille_Tot+Extrait_Le_Nom(j);j++;}
  }
  switch(j)
  {
  case 1:
   j=0;
   Maxi_Fichiers=0;
   Pas_Lift=(float)(MaxDY-1-(MinDY+22)-20)/24.0;
   break;
  default:
   j--;
   Maxi_Fichiers=j;
   if (j<=24)
     {Pas_Lift=(float)(MaxDY-1-(MinDY+22)-20)/24.0 ;}
     else
     {Pas_Lift=(float)(MaxDY-1-(MinDY+22)-20)/(float)Maxi_Fichiers;}
   qsort(Table_Fichier,j+1,sizeof(Table_Fichier[0]),strcmp);
   break;
   }
 }
 else
 {
  settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 sprintf(Tampon,"pas trouve %s\07",masque);
 outtextxy(300,MinDY+100,Tampon);
 Boof();
 sleep(2);
 escape=27;
 }
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 setcolor(11);
 j=0;
 if (escape!=27) Rafraichit_Liste_Fichiers(j);
 Milieu=FALSE;
 FormeSouris (4);
 while ((Milieu==FALSE) && (escape!=27))
 {
 EtatSouris();
 gotoxy(22,5);
 printf(" Fichier N%3d/%3d",j+1,Maxi_Fichiers+1);
 gotoxy(43,5);
 printf("Total %s =%8.1fK",masque,Taille_Tot);
 if ((Zone_Choix_Fichier)&&(Bouton>0)&&(Bouton<3)&&(x>MaxDX-55))
 {
  if ((y<MinDY+(MaxDY-MinDY)/2) && (y>MinDY+(MaxDY-MinDY)/2-24) && ((Bouton==1)||(Bouton==2)))
    {
     strcpy(Tampon," + ");
     TITRE(Tampon,MaxDX-33,MinDY+(MaxDY-MinDY)/2-16,2,12,1);
     j=(j<Maxi_Fichiers)?j+1:j;
	 Delai(100);
     strcpy(Tampon," + ");
     TITRE(Tampon,MaxDX-33,MinDY+(MaxDY-MinDY)/2-16,2,12,0);
     settextjustify(0,0);
    }
  if ((y>MinDY+(MaxDY-MinDY)/2)&&(y<MinDY+(MaxDY-MinDY)/2+24) &&((Bouton==1)||(Bouton==2)))
    {
     strcpy(Tampon," - ");
     TITRE(Tampon,MaxDX-33,MinDY+(MaxDY-MinDY)/2+16,2,10,1);
     j=(j>0)?j-1:j;
     Delai(100);
     strcpy(Tampon," - ");
     TITRE(Tampon,MaxDX-33,MinDY+(MaxDY-MinDY)/2+16,2,10,0);
      settextjustify(0,0);
     }
  Rafraichit_Liste_Fichiers(j);
  }
  if ((Zone_Choix_Fichier)&&(Bouton>0)&&(Bouton<3)&&(x<MaxDX-75)&&(Maxi_Fichiers>=1))
  {
  j=((float)y-((float)MinDY+22)+Pas_Lift/2)/Pas_Lift;
  j=(j>Maxi_Fichiers)?Maxi_Fichiers:j;
  j=(j<0)?0:j;
  Rafraichit_Liste_Fichiers(j);
  }
  if (kbhit()) escape=getch();
 }
if (escape!=27)
 {
 sleep(1);
 strncpy(Nom_Fichier,Table_Fichier[j],13);
 Nom_Fichier[12]=0;
 }
Bouton=0;
 PushSouris();
 FormeSouris(1);
 PopSouris();
free (entite);
free (Table_Fichier);
return(escape);
}

void ACQUISITION()
{
int ii;
	PushSouris();
	Balayage=(Balayage<MiniBalayage)?Balayage:MiniBalayage;
	OldInt1C=getvect(0x1c);
	setcolor(12);
	settextstyle(DEFAULT_FONT,1,1);
	outtextxy(18,Bp_Memory,"Memory");
	Indice=1;
	ii=MaxiPosition/400;
	/* fonction trigger */
	if (Seuil>1)
	{
		 do
		 {
			 if((char)(TL5494(ADC))>Seuil) break;
		 }
		 while (!kbhit()) ;
		if (kbhit()) fflush(stdin);
	}
	disable();
	Setup_Divisor(Balayage);
	setvect(0x1c,Traitement_1C);
	enable();
	while (Indice<MaxiPosition)
	 {
		 putpixel(MinDX+Indice/ii,MaxDY-1,12);
	};
	disable();
	Restore_1C();
	enable();
	fflush(stdin);
	DrpAcquis=TRUE;
	setfillstyle(SOLID_FILL,0);
	bar (MinDX,MinDY,MaxDX,MaxDY);
	setcolor(10);
	Position=1;
	MoveGrafePosition();
/*
i=1;
moveto(MinDX,MaxDY-(int)Mesure[1]);
 do
  {
  lineto(MinDX+i,MaxDY-(int)Mesure[i++]);
  }
 while (i<400);
 setcolor(10);
 */
	settextstyle(DEFAULT_FONT,1,1);
	outtextxy(18,Bp_Memory,"Memory");
	Indice=1;
	Duree_Point=Balayage;
	strcpy(Tampon,"S/Pts <.  .>");
	*(Tampon+8)=17;*(Tampon+11)=16;
	TITRE(Tampon,530,380,1,10,0);  /* en VERT !... */
	if(sprintf(Tampon,"%6d",Duree_Point)==0)Couine();
	setcolor(10);
	TITRE(Tampon,532,415,2,14,0);
	Position=1;
	AffichageValue(382,Position,6);
	AffichageValue(532,Balayage,6);
	PopSouris();
}


void Enregistrement()
{
 int i,j,ii;
	setcolor(12);
	settextstyle(DEFAULT_FONT,1,1);
	outtextxy(18,Bp_Memory,"Memory");
	Indice=1;
	ii=MaxiPosition/400;
 xD=*(RbT)+*(RbT+2)*65535;
 disable();
 do
 {
	  j=TL5494(ADC);
	  Mesure[Indice]=(char)j;
	  Indice++;
	 /* putpixel(MinDX+Indice/ii,MaxDY-1,12);*/
  }
  while (Indice<MaxiPosition);
  enable();
  xF=*(RbT)+*(RbT+2)*65535;
  xE=xF-xD;         /* duree en 1/18 eme de secondes */
  Ecart=(1000000.0*xE)/(18.2*MaxiPosition);
  Duree_Point=(int)Ecart;
  if (Duree_Point==0) { Burp(); Duree_Point=9999;} else Duree_M=Duree_Point;
  strcpy(Tampon,"S/Pts <.  .>");
  *(Tampon+8)=17;*(Tampon+11)=16;
  TITRE(Tampon,530,380,1,10,0);  /* en VERT !... */
  if(sprintf(Tampon,"%6d",Duree_Point)==0)Couine();
  setcolor(10);
  TITRE(Tampon,532,415,2,14,0);
  MoveGrafePosition();
  setcolor(10);
  settextstyle(DEFAULT_FONT,1,1);
  outtextxy(18,Bp_Memory,"Memory");
  Position=1;
  AffichageValue(382,Position,6);
}

void Ultra_Speed_Acquisition()
{
int i,j;
	PushSouris();
	setcolor(10);
	setfillstyle(SOLID_FILL,0);
	bar (MinDX,MinDY,MaxDX,MaxDY);
	Indice=1;
	disable();
	do
	{
		j=TL5494(ADC);
		Mesure[Indice]=(char)j;
		Indice++;
	}
	while (Indice<=400);
	enable();
	Duree_Point=Duree_M;
	if(sprintf(Tampon,"%6d",Duree_M)==0)Couine();
	setcolor(10);
	TITRE(Tampon,532,415,2,14,0);
	Position=1;
	MoveGrafePosition();
	PopSouris();
	Position=1;
	Indice=1;
 }

void Temps_reel_Acquisition()
{
int ii,i,j,k;
	setfillstyle(SOLID_FILL,0);
	bar (MinDX,MinDY,MaxDX,MaxDY);
	OldInt1C=getvect(0x1c);
	Indice=1;
	ii=MaxiPosition/400;
	/* fonction trigger */
	Indice=1;
	disable();
	Setup_Divisor(Balayage);
	setvect(0x1c,Traitement_1C);
	enable();
	while (Indice<=400)
	{
	/* attendons la fin....*/
	};
	disable();
	Restore_1C();
	enable();
	Position=1;
	MoveGrafePosition();
	Duree_Point=(int)Balayage;
	Position=1;
	Indice=1;
}

void Triggered_Acquisition_Directe()
{
 int i,j,k,l;
 bool DrpMilieu;
	l=(Balayage-MiniBalayage+1);
	if (l<MiniBalayage)l=MiniBalayage;
	PushSouris();
	DrpMilieu=FALSE;
	Indice=1;
	fflush(stdin);
	do
	{
		Delai_uS(l);
		if((char)TL5494(ADC)>Seuil) break;
	 }
	while (!kbhit()) ;
	if (kbhit()) fflush(stdin);
	Indice=1;
	xD=*(RbT)+*(RbT+2)*65535;
	do
	{
		Mesure[Indice]=(char)TL5494(ADC);
		Indice++;
		Delai_uS(l);
	}
	while (Indice<=1000);
	xF=*(RbT)+*(RbT+2)*65535;
	xE=xF-xD;         /* duree en 1/18 eme de secondes */
	Ecart=54.94505*xE;
	if (Ecart>0.0)
	{
		Duree_Point=(int)Ecart;
		}
		else
		{
		Burp(); Duree_Point=9999;
	}
	if(sprintf(Tampon,"%6d",Duree_Point)==0)Couine();
	setcolor(10);
	TITRE(Tampon,532,415,2,14,0);
	setfillstyle(SOLID_FILL,0);
	bar (MinDX,MinDY,MaxDX,MaxDY);
	setcolor(14);
	line(MinDX,MaxDY-Seuil,MinDX+Pg,MaxDY-Seuil);
	setcolor(6);
	line(MinDX+Pg,MaxDY-Seuil,MaxDX,MaxDY-Seuil);
	setcolor(11);
	Position=1;
	MoveGrafePosition();
	Indice=1;
	PopSouris();
}

void main (int argc,char *argv[])
{
  clrscr();
  MaxiPosition=60000L;
  nosound();
  RbT= MK_FP (0x0040,0x006c);
  AdjustMicroDelai();
  ADC=0x278;  /* valeur par dfaut LPt2=632 en decimal */
  if(argc>1)
  {
  argv[1]=strupr(argv[1]);
  k=argc-1;
  i=atoi(argv[1]);
  printf("\n\n Argument pass : %s soit %04Xh",argv[1],i);
  sleep(2);
  if (i!=0) ADC=i;
  if ((i!=0x278)&&(i!=0x378))
   {
    printf("\nTiens,tiens, ce n'est ni l'adresse de LPT 1,ni celle de LPT2 !(sur un AT !)");
    printf("\nAchtung,be carefull !");
    sleep(2);
   }
  }
  else
  {
   printf("\n\nPas d'argument pass...donc PORT =%04d = %04X par dfaut",ADC,ADC);
   Burp();
   sleep(2);
  }
  outportb(ADC,0);
  outportb(ADC+1,0);
  outportb(ADC,15);
  clrscr();
  Presentation();
  InitGraf();
  MinDX=161;
  MaxDX=560;
  MinDY=61;
  MaxDY=315;
  curs=(maskmouse *)farmalloc(130);
  if (curs==NULL)
  {
   Couine();
   exit(2);
   }
  Taille=imagesize(0,0,42,20);
  Glissiere=(char *)malloc(Taille);
  Poussoir =(char *)malloc(Taille);
  Taille=imagesize(MinDX,1,MaxDX,2);
  Un_Ligne=(char *)malloc(Taille);
  Deux_Ligne=(char *)malloc(Taille);
  Taille=imagesize(1,MinDY,2,MaxDY);
  Un_Colonne=(char *)malloc(Taille);
  Deux_Colonne=(char *)malloc(Taille);
  Taille=imagesize(0,0,17,50);
  BpMarche=(char *)malloc(Taille);
  BpArret=(char *)malloc(Taille);
  BdT=(char *)malloc(32);
  BdF=(char *)malloc(32);
  Format=(char *)malloc(32);

  masque=(char *)malloc(64);
  TamponD=(char *)malloc(64);
  TamponH=(char *)malloc(64);
  Tampon=(char *)malloc(220);
  Mesure=(byte *)malloc(MaxiPosition+4);
  if (Mesure==NULL)
  {
  gotoxy(3,4);
  printf("\nPb taille mmoire...insuffisante");
  Couine();
  sleep(3);
  exit(1);
  }
  _fmode=O_BINARY;
  InitSouris(1);
  clearviewport();
  settextstyle(DEFAULT_FONT,0,0);

/*-------- definition Bouton Marche ------- */
  x=50;y=400;
  LargBp=16;
  HautBp=25;
  setcolor(15);
  rectangle(x,y,x+LargBp,y+2*HautBp-1);
  setfillstyle(SOLID_FILL,7);
  bar(x+1,y+1,x+LargBp-1,y+HautBp-2);
  line(x,y+HautBp-1,x+LargBp,y+HautBp-1);
  setfillstyle(SOLID_FILL,0);
  floodfill(x+1,y+HautBp+1,15);
  setcolor(0);
  setlinestyle(SOLID_LINE,0,1);
  line(x+1,y+HautBp-2,x+LargBp,y+HautBp-2);
  line(x+LargBp,y+1,x+LargBp,y+HautBp-2);
  settextstyle(DEFAULT_FONT,0,0);
  outtextxy(x+LargBp/3,y+HautBp/3,"M");
  getimage(x,y,x+LargBp,y+HautBp*2,BpMarche);

/* --------------definition  Bouton ARRET -------------*/
  x=150;y=400;
  setcolor(15);
  rectangle(x,y,x+LargBp,y+HautBp*2-1);
  setfillstyle(SOLID_FILL,7);
  bar(x+1,y+1,x+LargBp-1,y+HautBp*2-2);
  line(x,y+HautBp-1,x+LargBp,y+HautBp-1);
  setfillstyle(SOLID_FILL,0);
  floodfill(x+LargBp/3,y+HautBp/3,15);
  setcolor(0);
  setlinestyle(SOLID_LINE,0,1);
  line(x+1,y+HautBp*2-1,x+LargBp,y+HautBp*2-1);
  line(x+LargBp,y+HautBp-1,x+LargBp,y+HautBp*2-1);
  settextstyle(DEFAULT_FONT,0,0);
  outtextxy(x+LargBp/3,y+HautBp*2-textheight("H")-4,"A");
  getimage(x,y,x+LargBp,y+HautBp*2-1,BpArret);

/* fond GRIS CLAIR */

  setfillstyle(SOLID_FILL,7);
  bar (0,0,MaxX,MaxY);
  setcolor(7);

/* Partie ECRAN */
  setfillstyle(SOLID_FILL,0);
  bar (160,60,560,316);
  setcolor(15);
  line (561,61,561,316);
  line (160,316,561,316);
  line(160,60,560,60);
  line(160,60,160,316);

/* glissiere selecteur */
  bar (100,70,105,270);
  setcolor(15);
  line (105,70,105,270);
  line (104,70,104,270);
  line (101,269,104,269);
/* graduations selecteur 0  9 pour 0  5 Volts */
  settextstyle(SANS_SERIF_FONT,0,1);
  for (i=70;i<270;i=i+20)
  {
   setcolor(0);   line(78,i,120,i);   k=(270+1-i)/20;
   setcolor(6);   itoa(k-1,Tampon,10);   outtextxy(65,i-8,Tampon);
   }
  getimage(80,100,122,100+20,Glissiere);

/* Bouton selecteur */
  setcolor(7);
  TITRE("<>",196,196,1,10,0);
  getimage(175,188,217,205,Poussoir);
  setfillstyle(SOLID_FILL,0);
  bar (MinDX,MinDY,MaxDX,MaxDY);

  setcolor(15);                   /* Vous n'etes pas autoris a enlever ce sigle*/
  strcpy(Tampon,CopyRight);       /* <- you are not agree to remove this ! */
  outtextxy(580,30,Tampon);


  setcolor(7);
  SIGLE
  TITRE("Trigger",102,285,1,10,0);
  strcpy(Tampon,"S/Pts <.  .>");
  *(Tampon+8)=17;*(Tampon+11)=16;
  TITRE(Tampon,530,380,1,12,0);
  strcpy(Tampon,"Posit < .  . >");
  *(Tampon+8)=17;*(Tampon+12)=16;
  TITRE(Tampon,382,380,1,10,0);
  TITRE(" CHOIX ",102,380,1,10,0);
  DXsouris(4,MaxX); DYsouris(4,MaxY);
  DeplaceSouris(102,250);
  y=250;

  /* positionne curseur dans glissiere */
  Vieuxy=(y/20)*20;
  putimage(80,Vieuxy,Glissiere,COPY_PUT); /* glissiere selecteur trigger */
  Gauche=0; k=(y/20)*20;
  putimage(80,k,Poussoir,COPY_PUT);   /* BP selecteur trigger */
  Vieuxy=k;

  setcolor(15);
  rectangle(8,366,49,440);      /* Bouton power */
  rectangle(8,55,49,360);       /* Boutons Memoire ,fichier ,... */
  rectangle(55,55,149,360);     /* trigger */
  rectangle(55,365,148,440);    /* choix Time ou volt */
  rectangle(154,365,300,440);   /* affiche Time ou Volt */
  rectangle(304,365,462,440);   /* pointeur */
  rectangle(466,365,600,440);   /* balayage */
  setcolor(0);
  setlinestyle(SOLID_LINE,0,3);
  line(9,439,49,439); 		/* Zone Bouton power */
  line(49,366,49,439);

  line(49,56,49,359);		/* zone BP memoire,fichier ...*/
  line(8,359,49,359);

  line(148,56,148,359);        	/* trigger */
  line(56,359,148,359);
  line(56,439,148,439);        	/* choix Time ou volt  */
  line(148,366,148,439);

  line(153,439,299,439);       	/* affiche time ou volt */
  line(299,366,299,439);

  line(305,439,461,439);
  line(461,365,461,439);

  line(467,439,599,439);
  line(599,366,599,439);

  Rivet(14,14,8);
  Rivet(14,462,8);
  Rivet(626,14,8);
  Rivet(626,462,8);

/* repere pour choix Volt ou Time */
   setcolor(4);
   outtextxy(73,426,"Volt");
   outtextxy(99,426,"|");
   outtextxy(127,426,"Time");

/* graduations Ordonnee droite Volts */
  setcolor(2);
  setlinestyle(SOLID_LINE,0,1);
  settextstyle(DEFAULT_FONT,0,1);
  for (i=60;i<317;i=i+16)
  {
   Volt=(316-i)*5.00/256;
   if(sprintf(Tampon,"%3.2f",Volt)==0) Couine();
   setcolor(14);
   line(562,i,570,i);
   outtextxy(590,i,Tampon);
  }

/* graduations abscisses TEMPS */
  for (i=0;i<401;i=i+50)
  {
   setcolor(4);
   itoa(i,Tampon,10);
   outtextxy(160+i,330,Tampon);
   line(160+i,316,160+i,320);
  }
  Calibration=TRUE;
  Mise_Hors_Tension();
  Uncal(TRUE);

Position=1;
AffichageValue(382,Position,6);
vieilY1=0xFFFF;
vieilY2=0xFFFF;
vieilX1=0xFFFF;
vieilX2=0xFFFF;
Bouton=0;
Duree_Point=9999;
Duree_M=9999;
Balayage=MiniBalayage=400/MicroDelai;
AffichageValue(532,Balayage,6);
MaxiBalayage=30000;
Volt=0;
DrpMarq=0;
Seuil=0;
SeuilTrigger=0.0;
if(sprintf(Tampon,"%5.2f",SeuilTrigger)==0) Couine();
TITRE(Tampon,102,320,2,14,0);
DeplaceSouris(32,388);
PopSouris();

/* ----             MAIN BOUCLE           ------- */
while (Bouton!=7)
 /* G + D +M =7 =3 boutons enfoncs,mais avec une souris 2 boutons ?
    hein,commnent je vais faire ?
	Power OFF bien sur !! */
{
 EtatSouris();
 if (DrpDirect==FALSE)
  {
   if (Zone_Trace_Grafe)
    {
     gotoxy(8,3);
     Volt=Mesure[Position+x-MinDX+3]*5.00/255;
     printf("Valeur=%2.2f",Volt);
     }
     else
     {
     gotoxy(8,3);
     printf("x=%3dy=%3d",x,y);
    }
   }
   else
   {
   Delai(60);
 }
 if ((DrpDirect==TRUE)&&(DrpMemory==FALSE))
 {
 if (Calibration==FALSE)
   {
   /* via Pooling */
   if(Seuil==0)Ultra_Speed_Acquisition();else Triggered_Acquisition_Directe();
   }
  else
  {
  /* via interruption */
  Temps_reel_Acquisition();
  }
 Delai(30);
 }
 EtatSouris();
 if((Power==TRUE)&&(Bouton!=0)&&(Zone_Trace_Grafe))
 {
  if(AfficheVolt==TRUE)
  {
  FormeSouris (3);
  DYsouris(MinDY,MaxDY);
  if ((Gauche==1)&&((DrpMarq & 1)==0))
   {
	TITRE("Debut V ",234,380,1,10,0);
    while (Gauche==1)
     {
     PushSouris();
     if (vieilY1!=0xFFFF) {putimage(MinDX,vieilY1,Un_Ligne,COPY_PUT); }
     Volt=A_Volt=(MaxDY-y)*5.00/256;
     if(sprintf(Tampon,"%7.3f",Volt)==0) Couine();
     TITRE(Tampon,234,415,2,14,0);
     setcolor(5);
     getimage(MinDX,y,MaxDX,y,Un_Ligne);
     setlinestyle(DOTTED_LINE,1,1);
     line(MinDX,y,MaxDX,y);
     vieilY1=y;
     setlinestyle(SOLID_LINE,1,1);
     PopSouris();
     EtatSouris();
	 Delai(20);
     }
    DrpMarq=DrpMarq | 1;
   };
   if ((Droite==2)&& ((DrpMarq & 2)==0))
   {
    TITRE(" Fin V  ",234,380,1,10,0);
    while (Droite==2)
    {
     PushSouris();
     if (vieilY2!=0xFFFF)  { putimage(MinDX,vieilY2,Deux_Ligne,COPY_PUT);}
     Volt=B_Volt=(MaxDY-y)*5.00/256;
     if(sprintf(Tampon,"%7.3f",Volt)==0) Couine();
     TITRE(Tampon,234,415,2,14,0);
     setcolor(5);
     getimage(MinDX,y,MaxDX,y,Deux_Ligne);
     setlinestyle(DOTTED_LINE,1,1);
     line(MinDX,y,MaxDX,y);
     vieilY2=y;
     setlinestyle(SOLID_LINE,1,1);
     PopSouris();
     EtatSouris();
	 Delai(20);
     }
     DrpMarq=DrpMarq | 2;
   };
   if (Milieu==TRUE && (DrpMarq & 3)==3)
   {
    PushSouris();
    Droite=Gauche=0;
    TITRE("Delta.V ",234,380,1,10,0);
    Volt=(A_Volt>B_Volt)?A_Volt-B_Volt:B_Volt-A_Volt;
    if (Volt==0.0) Volt=0.0001;
    if(sprintf(Tampon,"%7.3f",Volt)==0) Couine();
    strcat(Tampon," V");
    settextstyle(DEFAULT_FONT,0,0);
    outtextxy(x,y,Tampon);
    DrpMarq=4;
    AfficheVolt=FALSE;
    DYsouris(4,MaxY);
	PopSouris();
	Delai(20);
   };
   if(sprintf(Tampon,"%7.3f",Volt)==0) Couine();
    TITRE(Tampon,234,415,2,14,0);
    setlinestyle(SOLID_LINE,1,1);
    FormeSouris (1);
   }
  if(AffichePeriode==TRUE)
  {
   FormeSouris (3);
   DXsouris(MinDX+1,MaxDX);
   if ((Gauche==1)&&((DrpMarq & 1)==0))
    {
     strcpy(BdT,"Debut X ");
     TITRE(BdT,234,380,1,10,0);
     while(Gauche==1)
     {
      PushSouris();
     if (vieilX1!=0xFFFF)  { putimage(vieilX1,MinDY,Un_Colonne,COPY_PUT);}
     Periode=(float)(x-MinDX-1+Position);
     A_Periode=Periode*Duree_Point;
     Freq=Periode;
     if(sprintf(Tampon,"%7.0f",Freq)==0) Couine();
     TITRE(Tampon,234,415,2,14,0);
     setcolor(4);
     getimage(x,MinDY,x,MaxDY,Un_Colonne);
     setlinestyle(CENTER_LINE,1,1);
     line(x,MinDY,x,MaxDY);
     vieilX1=x;
     setlinestyle(SOLID_LINE,1,1);
     PopSouris();
     EtatSouris();
	 Delai(20);
     };
     DrpMarq=DrpMarq | 1;
   }
   if ((Droite==2)&&((DrpMarq & 2)==0))
   {
     strcpy(BdT," Fin  X ");
     TITRE(BdT,234,380,1,10,0);
     while(Droite==2)
     {
     PushSouris();
     if (vieilX2!=0xFFFF)  { putimage(vieilX2,MinDY,Deux_Colonne,COPY_PUT);}
     Periode=x-MinDX-1+Position;
     B_Periode=Periode*Duree_Point;
     Freq=Periode;
     if(sprintf(Tampon,"%7.0f",Freq)==0) Couine();
     TITRE(Tampon,234,415,2,14,0);
     setcolor(4);
     getimage(x,MinDY,x,MaxDY,Deux_Colonne);
     setlinestyle(CENTER_LINE,1,1);
     line(x,MinDY,x,MaxDY);
     vieilX2=x;
     setlinestyle(SOLID_LINE,1,1);
     PopSouris();
     EtatSouris();
	 Delai(20);
     };
     DrpMarq=DrpMarq | 2;
   }
   if (Milieu==TRUE && (DrpMarq & 3)==3)
   {
     PushSouris();
     Droite=Gauche=0;
     Periode=(A_Periode>B_Periode)?A_Periode-B_Periode:B_Periode-A_Periode;
     if (Periode==0) Periode=Duree_Point;
     if (Periode>1000000)
      {
      strcpy(BdT,"Time  S");
      Periode=Periode/1000000;
      Freq=1000/Periode;
      strcpy(BdF,"Freq mHz");
      }
      else
      {
       if (Periode>1000 )
       {
       strcpy(BdT,"Time mS");
       Freq=1000000/Periode;
       Periode=Periode/1000;
       strcpy(BdF,"Freq Hz ");
       }
       else
       {
       strcpy(BdT,"Time S");
       Freq=1000/Periode;
       strcpy(BdF,"Freq KHz");
       }
      }
     if(sprintf(Tampon,"%7.1f",Periode)==0) Couine();
     strcat(Tampon,BdT+4);
     settextstyle(DEFAULT_FONT,0,0);
     outtextxy(x,y,Tampon);
     strcpy(Tampon,BdF);
     TITRE(Tampon,234,380,1,10,0);
     if(sprintf(Tampon,"%7.2f",Freq)==0) Couine();
     TITRE(Tampon,234,415,2,14,0);
     DrpMarq=4;
     AffichePeriode=FALSE;
     DXsouris(4,MaxX);
     PopSouris();
     }
     else
     {
     strcpy(Tampon,BdT);
     TITRE(Tampon,234,380,1,10,0);
     if(sprintf(Tampon,"%7.0f",Freq)==0) Couine();
     TITRE(Tampon,234,415,2,14,0);
     setlinestyle(SOLID_LINE,1,1);
     }
    }
   FormeSouris (1);
 }
 if (Zone_Reglage_Trigger)
 {
   DYsouris(65,250);
   EtatSouris();
   if (Gauche==1)
   {
    PushSouris();
    Gauche=0;
    putimage(80,Vieuxy,Glissiere,COPY_PUT);
    Delai(20);
    k=(y/20)*20;
    putimage(80,k,Poussoir,COPY_PUT);
    Vieuxy=k;
    if(Power==TRUE)
     {
      SeuilTrigger=(240-k)*5.00/180;
      if(sprintf(Tampon,"%5.2f",SeuilTrigger)==0) Couine();
      TITRE(Tampon,102,320,2,14,0);
      Seuil=(int)(SeuilTrigger*255/5.00);
     }
      PopSouris();
   }
   DYsouris(4,MaxY);
   Delai(30);
 }
 if((Power==TRUE)&&(Bouton>0)&& Zone_Position)
 {
    if (DrpMarq==4) { BpChoix(1);Boof();}
    MouvementX=(x-410)/2;
    if (MouvementX>0)  MouvementX=MouvementX*MouvementX;
    if (MouvementX<0)  MouvementX=-(MouvementX*MouvementX);
    if (abs(MouvementX)>0)
    {
	if ((MouvementX>0)&&(Position+MouvementX<MaxiPosition-400)) Position=Position+MouvementX;
	if ((MouvementX<0)&&(Position+MouvementX>1)&&(Position+MouvementX<MaxiPosition-400)) Position=Position+MouvementX;
    if ((MouvementX<0)&&(Position>1)) Position--;
	if ((MouvementX>0)&&(Position<MaxiPosition-400))Position++;
    MoveGrafePosition();
	AffichageValue(382,Position,6);
	Delai(60);

	}
 }
 if ((Power==TRUE)&&(y>373)&& Zone_Balayage)
 {
   if (Bouton>0)
   {
    MouvementX=(x-562)/2;
    if (MouvementX>0)  MouvementX=MouvementX*MouvementX;
    if (MouvementX<0)  MouvementX=-(MouvementX*MouvementX);
    if (abs(MouvementX)>0)
    {
    if ((MouvementX>0)&&(Balayage+MouvementX<MaxiBalayage)) Balayage=Balayage+MouvementX;
    if ((MouvementX<0)&&(Balayage+MouvementX>MiniBalayage)) Balayage=Balayage+MouvementX;
    if ((MouvementX<0)&&(Balayage>MiniBalayage)) Balayage--;
    if ((MouvementX>0)&&(Balayage<MaxiBalayage)) Balayage++;
    }
    AffichageValue(532,Balayage,6);
	Delai(60);
   }
 }

 if (Zone_BP)
 {
   if ((Power==TRUE)&&(y>Bp_Hardcop-HautBp)&&(y<Bp_Hardcop)&&(DrpMemory==FALSE))
    {
     PushSouris();
     putimage(28,Bp_Hardcop-HautBp,BpMarche,COPY_PUT);
     setcolor(10);
     settextstyle(DEFAULT_FONT,1,1);
     outtextxy(18,Bp_Hardcop,"HardCop");
	 Hardcopy();
	 putimage(28,Bp_Hardcop-HautBp,BpArret,COPY_PUT);
     setcolor(0);
     outtextxy(18,Bp_Hardcop,"HardCop");
	 Bouton=0;
	 PopSouris();
 }
 if ((Power==TRUE)&&(y>Bp_Print-HautBp)&&(y<Bp_Print)&&(DrpMemory==FALSE))
 {
     PushSouris();
     putimage(28,Bp_Print-HautBp,BpMarche,COPY_PUT);
     setcolor(10);
     settextstyle(DEFAULT_FONT,1,1);
     outtextxy(18,Bp_Print," Print ");
     Print_Out_Values();
     putimage(28,Bp_Print-HautBp,BpArret,COPY_PUT);
	 sleep(1);
	 setcolor(0);
	 outtextxy(18,Bp_Print," Print ");
	 Bouton=0;
     PopSouris();
 }
 if ((Power==TRUE)&&(DrpDirect==FALSE)&&(y<Bp_Memory-1)&&(y>Bp_Memory-HautBp)&&(DrpAcquis==FALSE))
 {
     PushSouris();
     DrpMemory=TRUE;
     putimage(28,Bp_Memory-HautBp,BpMarche,COPY_PUT);
	 for (i=0;i<MaxiPosition;i++) Mesure[i]=0;
     setfillstyle(SOLID_FILL,0);
     bar (MinDX,MinDY,MaxDX,MaxDY);
     vieilX1=0xFFFF;
     vieilX2=0xFFFF;
     vieilY1=0xFFFF;
     vieilY2=0xFFFF;
     Position=1;
     AffichageValue(382,Position,6);
     Indice=1;
     if (Calibration==TRUE) ACQUISITION(); else Enregistrement();
     DrpAcquis=TRUE;
     PopSouris();
 }
 if ((Power==FALSE)||(((y<Bp_Memory+HautBp)&&(y>Bp_Memory))))
 {
       PushSouris();
       DrpMemory=FALSE;
       DrpAcquis=FALSE;
       putimage(28,Bp_Memory-HautBp,BpArret,COPY_PUT);
       setcolor(0);
       settextstyle(DEFAULT_FONT,1,1);
       outtextxy(18,Bp_Memory,"Memory");
       PopSouris();
 }
 if((Power==TRUE)&&(DrpDirect==FALSE)&&(y>Bp_File-HautBp)&&(y<Bp_File))
 {
	PushSouris();
	DrpFile=TRUE;
	putimage(28,Bp_File-HautBp,BpMarche,COPY_PUT);
	setcolor(10);
	settextstyle(DEFAULT_FONT,1,1);
	outtextxy(18,Bp_File,"Fichier");
	settextstyle(DEFAULT_FONT,0,1);
	setfillstyle(SOLID_FILL,8);
	bar(MinDX,MinDY,MaxDX,MaxDY);
	settextstyle(DEFAULT_FONT,0,0);
	x=50;y=400;
	setcolor(7);
   /* Partie ECRAN */
	setfillstyle(SOLID_FILL,0);
	bar (MinDX,MinDY,MaxDX,MaxDY);
	setcolor(15);
	y=250;
	PopSouris();
	Position=1;
	f1=(FILE *)malloc(sizeof(FILE));
	settextstyle(DEFAULT_FONT,0,0);
	rectangle (MinDX+1,MinDY+1,MaxDX-1,MinDY+22);
   /* plaque support 2 boutons */
	setfillstyle(CLOSE_DOT_FILL,7);
	bar (MaxDX-2,MinDY+25,MaxDX-66,MaxDY-2);
	setlinestyle(SOLID_LINE,0,3);
	setcolor(0);
	line(MaxDX-67,MaxDY-1,MaxDX-1,MaxDY-1);
	line(MaxDX-1,MinDY+24,MaxDX-1,MaxDY-1);
   /* 2 boutons */
	setlinestyle(SOLID_LINE,8,1);
	strcpy(Tampon," + ");
	TITRE(Tampon,MaxDX-33,MinDY+(MaxDY-MinDY)/2-16,2,12,0);
	strcpy(Tampon," - ");
	TITRE(Tampon,MaxDX-33,MinDY+(MaxDY-MinDY)/2+16,2,10,0);
	settextjustify(0,0);
	setcolor(15);
	Pos_Lift=0;
	DeplaceSouris(MaxDX-5,MinDY+(MaxDY-MinDY)/2);
	DYsouris(MinDY+22,MaxDY);
	DXsouris(MaxDX-80,MaxDX-1);  /* was MaxDX-32 is MinDX */
	fflush(stdin);
	if (Choix_Liste_Fichier()!=27)
	 {
	 BoiteDialogue(0);
	 strcpy(Tampon,"File : ");
	 strcat(Tampon,Nom_Fichier);
	 bar(170,350,170+textwidth(Tampon),350+textheight(Tampon));
	 outtextxy(170,354,Tampon);
	 gotoxy(22,5);printf("                                             ");
	 gotoxy(25,5);printf(" <L>ecture   ou    <E>criture  ");
	 DeplaceSouris(MinDX+(MaxDX-MinDX/2),MinDY+3);
	 DYsouris(MinDY+1,MinDY+20);
	 DXsouris(MinDX+40,MaxDX-40);
	 c=0;
	 do
	 {
	 EtatSouris();
	 gotoxy(8,3);
	 printf("x=%3dy=%3d",x,y);
	 if ((y>MinDY))
	 {
	 if ((Gauche==1)&&(x>MinDX)&&(x<MinDX+(MaxDX-MinDX)/2))
	  {
	   PushSouris();
	   Fichier_Lu=LisFichier();
	   setfillstyle(SOLID_FILL,0);
	   setcolor(0);
	   bar(MinDX,MinDY,MaxDX,MaxDY);
	   Position=1;
	   Indice=1;
	   if (Fichier_Lu > 0L)
	   {
	   Fichier_Lu=0;
	   }
	   else
	   {
	    setcolor(0);
	    BoiteDialogue(7);
	   }
	   PopSouris();
	   break;
	  }
	if((Droite==2)&&(x>MinDX+(MaxDX-MinDX)/2)&&(x<MaxDX-1))
	 {
	 PushSouris();
	 BoiteDialogue(0);
	 bar(MinDX+1,MinDY+1,MaxDX-1,MinDY+20);
	 gotoxy(25,5);printf("Nom =");
	 scanf("%s",Nom_Fichier);
	 if (strlen(Nom_Fichier)>3)
	 {
	  strcpy(Tampon,Nom_Fichier);
	  outtextxy(170,354,Tampon);
	  EcrisFichier();
	  setcolor(0);
	  bar(MinDX,MinDY,MaxDX,MaxDY);
	  Position=1;
	  Indice=1;
	  PopSouris();
	  break;
	  }
	  else
	  {
	  Couine();
	  PopSouris();
	  break;
	  }
	 }
	 PopSouris();
	 }
	 if (kbhit()) c=getch();
	 }
	 while((Milieu==FALSE)&&(c!=27));
	 }
	PushSouris();
	setcolor(0);
	bar(MinDX,MinDY,MaxDX,MaxDY);
	Position=1;
	Indice=1;
	if (c==27) BoiteDialogue(7);
	DeplaceSouris(MaxX/2,MaxY/2);
	DYsouris(5,MaxY-5);
	DXsouris(5,MaxX-5);
  	setcolor(7);
	SIGLE
	DrpFile=FALSE;
	putimage(28,Bp_File-HautBp,BpArret,COPY_PUT);
	Position=1;
	MoveGrafePosition();
	AffichageValue(382,Position,6);
	setcolor(0);
	settextstyle(DEFAULT_FONT,1,1);
	outtextxy(18,Bp_File,"Fichier");
	setfillstyle(SOLID_FILL,0);
	PopSouris();
  }
  if ((Power==TRUE)&&(y>Bp_Direct-HautBp)&&(y<Bp_Direct-1)&&(DrpMemory==FALSE))
  {
	PushSouris();
	DrpDirect=TRUE;
	BpChoix(1);
	setcolor(10);
	settextstyle(DEFAULT_FONT,1,1);
	outtextxy(18,Bp_Direct," Direct ");
	putimage(28,Bp_Direct-HautBp,BpMarche,COPY_PUT);
	vieilY1=0xFFFF;
	vieilY2=0xFFFF;
	PopSouris();
  }
  if ((Power==FALSE)||((y>Bp_Direct+1)&&(y<Bp_Direct+HautBp)))
  {
	PushSouris();
	DrpDirect=FALSE;
	putimage(28,Bp_Direct-HautBp,BpArret,COPY_PUT);
	setcolor(0);
	settextstyle(DEFAULT_FONT,1,1);
	outtextxy(18,Bp_Direct," Direct ");
	PopSouris();
 }
 if ((y>Bp_Power-HautBp)&&(y<Bp_Power))
 {
	 PushSouris();
	 Power=TRUE;
	 vieilY1=0xFFFF;
	 vieilY2=0xFFFF;
	 vieilX1=0xFFFF;
	 vieilX2=0xFFFF;
	 putimage(28,Bp_Power-HautBp,BpMarche,COPY_PUT);
	 if(sprintf(Tampon,"%5.3f",SeuilTrigger)==0) Couine();
	 setcolor(11);
	 settextstyle(DEFAULT_FONT,1,1);
	 outtextxy(18,Bp_Power,"Power");
	 TITRE(" Choix  ",102,380,1,10,0);
	 BpChoix(1);
	 PopSouris();
 }
 if ((y>Bp_Power)&&(y<Bp_Power+HautBp))
 {
	   PushSouris();
	   Power=FALSE;
	   Mise_Hors_Tension();
	   break;
   }
 }
 EtatSouris();
 Delai(20);
 if ((Bouton>0)&&(y>400)&&(x<140)&&(x>54)&&(y<420))
 {
     if (DrpDirect==FALSE)
     {
      PushSouris();
      if (x<80) 		BpChoix(0);
      if ((x>86)&&(x<110))	BpChoix(1);
      if ((x>116)&&(x<140))	BpChoix(2);
      PopSouris();
      }
 }
 if((Bouton>0)&&(x>600)&&(y>360)&&(x<620)&&(y<MaxY)&&(Power==TRUE))
 {
     PushSouris();
     if (Gauche==1) Uncal(TRUE);
     if (Droite==2) Uncal(FALSE);
     PopSouris();
  }
Bouton=0;
}
/* ---------------- FIN de BOUCLE -----------------*/
PushSouris();
Rideau();
}
#endif
