/*
 version 0.0 03 juillet 97
 tst7572.diz
 (c)PF
Ŀ
 Nom    : Tst7572c.c        DOS 6.22    Video : EGA,VGA Cirrus GD5424 
 Date   : 03/07/97          Materiel:   EET 486 DXII 66mhz            
 Auteur : P.FREYER          Langage :   Turbo C v2.00 Borland         
 But    : Mesurer et visualiser de 1 signal      electriq. 0-5 Volts  
          via circuit AD 7572 ADC 12 bits mode parallele,1 voie.      
          vitesse plus elevee 3,5S par channel donne constructeur   
          acquisition en mode parallele en 2 lectures...100% en C     
          necessite un port parallel bi-directionnel.                 
 Historique Revisions:                                                

*/

#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <Bios.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include <graphics.h>
#include <alloc.h>

#define EN_C
#include "c:\tc\scope\enregist.scp"
char Interface[]={"Tst7572c 1voie 12bits (AD7572.sdr)"};
char CopyRight[]={"Tst7572c.c 1997 (c)P.Freyer"};
char Version[]={"(C)P.F.V1.0 15-07-97"};

typedef enum {FALSE,TRUE} bool;
typedef unsigned char byte;
typedef unsigned int word;

word k1;
word i,j,k,l,m,n;
word x,y,x1,y1;
word Lptx,mot,k1;

word Valeur_LSB,Valeur_MSB,Valeur;
int CarteGraphique;
int ModeGraphique;
int ErrorCode;
int MinX,MinY,MaxX,MaxY;

char c;
char far *mes;
float te,tf;
int  ;
word Mesure[25000];
word Zoom;
int Tmax;

#define IRQ_DISABLE  mot=mot & 0xFFEF;outportb(Lptx+2,mot);  /* passage ACK sur IRQ disabl */
#define IRQ_ENABLE   mot=mot | 0x0010;outportb(Lptx+2,mot);  /* passage ACK sur IRQ OK */
#define HBEN_0       mot=mot & 0xFFFB;outportb(Lptx+2,mot);  /* 16 Init Prt A0=0*/
#define HBEN_1       mot=mot | 0x0004;outportb(Lptx+2,mot);  /* 16 Init Prt A0=1*/
#define modeLECT    mot=mot | 0x0020;outportb(Lptx+2,mot);
#define CS_1        mot=mot & 0xFFFD;outportb(Lptx+2,mot); /*14 autofeed CS=1*/
#define CS_0        mot=mot | 0x0002;outportb(Lptx+2,mot); /*14 autofeed CS=0*/
#define RD_1        mot=mot & 0xFFFE;outportb(Lptx+2,mot); /* 1 strobe RD=1 */
#define RD_0        mot=mot | 0x0001;outportb(Lptx+2,mot); /* 1 strobe RD=0 */
#define testACK     while ((inportb(Lptx+1) && 64)==64) {};


struct time T1;

void moment()
{
int t;
for (t=1;t<Tmax;t++);
}

void Lecture_AD7572()
{
/*
  Analog Device AD7572JN12  ADC 12 bits 1 voie  +5V -12V alims
  10S lecture en mode 2x Bits
*/
word i;
#ifdef DEBUG
	Valeur=2041+random(300);
#else
disable();
HBEN_0;
/* CS_0;RD_0;*/
mot=mot | 0x0003;outportb(Lptx+2,mot);
Valeur_LSB= inportb(Lptx);
/* RD_1 CS_1 */
mot=mot & 0xFFFC;outportb(Lptx+2,mot);
while ((inportb(Lptx+1) && 64)==64){};
HBEN_1;
/* CS_0 RD_0 */
mot=mot | 0x0003;outportb(Lptx+2,mot);
Valeur_MSB=inportb(Lptx);
/* RD_1 CS_1 */
mot=mot & 0xFFFC;outportb(Lptx+2,mot);
Valeur=Valeur_MSB << 8;
Valeur=Valeur+ Valeur_LSB;
enable();
#endif
}


float Duree (void)
{
float TT1,c1,c2,c3;
gettime(&T1);
c1=(float)T1.ti_sec;
c2=(float)T1.ti_hund;
c3=(float)T1.ti_min;
TT1=c3*60+c1+c2/100.0;
return(TT1);
}

void Pause()
{
do
 {}
while (!kbhit()) ;
c=getch();
};

void InitGraf()
{
 word i;
 printf("\nInitgraf.c");
 CarteGraphique=VGA;
 ModeGraphique=VGAHI;
 i=registerfarbgifont(triplex_font_far);
 if (i!=1)
  {
	printf("\nPb font TRIP non integree .. CR= %04X",i);
	sleep(2);
	exit(1);
   }
  i=registerfarbgifont(sansserif_font_far);
  if (i!=3)
	{
	printf("\nPb font SANS non integree ..CR=%04X",i);
	sleep(2);
   exit(1);
   }
  i=registerfarbgidriver(EGAVGA_driver_far );
  if (i<0)
  {
	printf("\nPb Driver EGAVGA non integree ..CR=%04X ",i);
	sleep(2);
   exit(1);
   }
  initgraph(&CarteGraphique,&ModeGraphique,"");
  ErrorCode=graphresult();
  if (ErrorCode!=grOk)
  {
  printf("\nerreur initialisation Grafique :%s \n",grapherrormsg(ErrorCode));
  sleep(2);
  exit(1);
  }
 MaxX=getmaxx();
 MaxY=getmaxy();
 printf("\n Max X=%5d MaxY=%5d",MaxX,MaxY);
 clearviewport();
}


void main (int argc,char *argv[])
{
Tmax=5;
if (argc>1) i=atoi(argv[1]);
if (i>9 && i<101) Tmax=i;
mes=(char *) farmalloc(512);
clrscr();
textcolor(14);
cprintf("TstAD7572 ADC 12 bits AD7572 (24 pins) et  Lptx Bi-directionnelle");
printf("\nVersion 1.0  100% en C            15/07/97 (C)P.F.  ");
printf("\nNota: duree mini clock ADC <5  1000>   ajuster en parametre");
printf("\n 1  Strobe    @+2  1  inv     ->  20 de AD7572  Read value");
printf("\n 14 Autofeed  @+2  2  inv     ->  21 de AD7572  ChipsSelect");
printf("\n 16 Init      @+2  4  norm    ->  19 de AD7572  HBEN select LSB ou MSB");
printf("\n 10 Ack       @+1  64 norm    <-  22 de AD7572  Busy fin de conversion");
printf("\n 2  D0        @+0  1          <-> 6  de AD7572  D0/D8");
printf("\n 3  D1        @+0  2          <-> 7  de AD7572  D1/D9");
printf("\n 4  D2        @+0  4          <-> 8  de AD7572  D2/D10");
printf("\n 5  D3        @+0  8          <-> 9  de AD7572  D3/D11");
printf("\n 6  D4        @+0  16         <-> 17 de AD7572  D4");
printf("\n 7  D5        @+0  32         <-> 18 de AD7572  D5");
printf("\n 8  D6        @+0  64         <-> 19 de AD7572  D6");
printf("\n 9  D7        @+0  128        <-> 20 de AD7572  D7");
printf("\n                                  15 sortie RDY    ");
printf("\n                                  1  Analog input  ");
printf("\n                                  2  reference tension  ");
printf("\n                                  23 alim -12 Volts     ");
printf("\n                                  17 18  Quartz 2Mhz    ");
printf("\n                                  24 +5v 12 Gnd  3 Agnd ");
printf("\n special  @+2  32  -> LPTx en mode Lecture \n");
mot=32;

textcolor(13);
cprintf("Choix port Lpt <1> ou <2> : ");
do
{
scanf("%1d",&i);
}
while (i<1 && i>2);
switch (i)
{
case 1:
Lptx=888;break;
case 2 :
Lptx=632;break;
default:
Lptx=888;break;
}
textcolor(15);
cprintf("Esc pour suite..");
mot=32;
modeLECT;
CS_1;
RD_1;
do
{
disable();
HBEN_0;
CS_0;
RD_0;
/*testACK;*/
k=0;
while ((inportb(Lptx+1) && 64)==0)
{
k++;
if (k>65000)break;
};
Valeur_LSB= inportb(Lptx);
RD_1;
CS_1;
HBEN_1;
moment();
CS_0;
RD_0;
Valeur_MSB=inportb(Lptx);
RD_1;
CS_1;
Valeur=Valeur_MSB*256+Valeur_LSB;
enable();
gotoxy(1,24);
printf(" k=%06u Valeur=%05d",k,Valeur);
if (kbhit()) c=(char) getch();
}
while(c!=27);
Zoom=16;
c=0;
InitGraf();
j=0;
Lecture_AD7572();
do
{
 te=Duree();
 for (j=0;j<25000;j++)
 {
	Lecture_AD7572();
	Mesure[j]=Valeur;
 }
 tf=Duree();
 te=tf-te;
 setviewport(1,1,679,20,1);
 clearviewport();
 i=sprintf(mes,"P=pause ESC=sortie  %06.2fS pour 1 mesure   Zoom (+ ou -) =%6d",te*1000000/25000,Zoom);
 outtextxy(2,1,mes);
 setviewport(200,121,670,421,0);
 /* en mode ligne */
 setcolor(2);
 line(1,384,639,384);
 setcolor(14);
 moveto  (1,384- Mesure[0]/Zoom);
 putpixel(1,384- Mesure[0]/Zoom,12);
 setcolor(12);
 for (x=1;x<640;x++) lineto(x,384-Mesure[x]/Zoom);
 setviewport(1,20,679,1,1);
 if (kbhit())  c=(char) getch();
 if ((c=='P')||(c=='p'))
 {
      i=sprintf(mes,"- Pause      -");
      outtextxy(460,470,mes);
      do
      {}
      while (!kbhit());
      i=sprintf(mes,"-            -");
      outtextxy(460,1,mes);
      c=0;
 }
 if (c=='+')
 {
      c=0;
      if (Zoom>1)Zoom=Zoom/2;
 }
  if (c=='-')
 {
      c=0;
      if (Zoom<64)Zoom=Zoom*2;
 }

 }
 while(c!=27);
 c=0;
 closegraph();
 farfree(mes);
 printf("\n\n Fin normale de programme....");
 printf("\n Version : %s",Version);
 printf("\n Interface : %s",Interface);
 printf("\nResultat obtenu : 13  14 S par point (moyenne sur 25000 mesures)");
 printf("\n sur 486DXII 66Mhz carte Lptx bus ISA modifie pour lecture\n\n");
 sleep(1);
}
